<?

class CNTagCollection extends CNInFolderObject {
 
 function CNTagCollection() {
 parent::CNObject();
 }
 
 





 function getTagNames($parentTags = false) {
 }

 function &getTag($tagname) {
 }

 function getMlID() {
 }
}

class CNPageObject extends CNTagCollection {

 var $page_id;
 var $d_tags;
 var $d_versions;
 var $d_tagsInitialized;
 var $d_versionsInitialized;

 function CNPageObject($id = 0) {
 parent::CNTagCollection();
 $this->setID($id);
 $this->setViewLinkParams("do=14001&PAGE_ID=" . $this->getId());
 }
 
 function searchInObject($objecttype, $objectid, $searchterm=null, $recursive=false, $fulltext=false, $ignoreorder=false) {
 global $CONTENTGROUP_ID, $FEATURE, $NODE_ID;
 if (! in_array($objecttype, $this->getParentTType())) {
 return null;
 }

 $searchsql = "";
 if ($searchterm) {
 $searchsql = " AND (LOWER(page.name) LIKE '%" . sqlslashes($searchterm) . "%') ";
 }
 $sort = '';
 if( !$ignoreorder ) {
 $sort = item_order("name", "ASC", array("page.name"=>"name","page.filename"=>"filename","page.description"=>"description","template.name"=>"tname","folder.name"=>"folder"));
 }
 $channelId = 0;
 if ($FEATURE["multichannelling"]) {
 
 $folder = new CNFolderObject($objectid);
 $objectid = $folder->getMasterId();

 
 $nodeInfo = get_nodeinfo($NODE_ID);
 if ($nodeInfo["master_id"]) {
 $channelId = $NODE_ID;
 }

 node_include("keymapper");
 $km = new KeyMapper(array(
 "fileName" => "filename",
 "cdate" => "pcdate",
 "edate" => "pedate",
 "language" => "code",
 "template.name" => "tname",
 "template.id" => "template_id",
 "creator.firstName" => "pc_firstname",
 "creator.lastName" => "pc_lastname",
 "editor.firstName" => "pe_firstname",
 "editor.lastName" => "pe_lastname",
 "channelId" => "channel_id",
 "languageVariants" => "lang",
 "folderId" => "folder_id",
 "timeManagement.at" => "time_pub",
 "path" => "folder",
 "lockedSince" => "locked",
 "lockedBy.id" => "locked_by"
 ));

 $pages = getPagesFromREST($objectid, $CONTENTGROUP_ID, "", $searchterm, $sort, $km, 0, -1, false, false, $channelId, false);
 } else {
 $folders = array();
 if ($objectid) {
 if ($searchterm && $recursive) {
 mini_walk($folders, $objectid);
 }
 $folders[] = $objectid;
 }
 $pages = get_pages($objectid, $CONTENTGROUP_ID, "", $folders, $searchsql, $sort, false, 0, 0, $channelId);
 }
 return $this->_processResultset(array("arr"=>$pages));
 }

 function getTType()
 {
 global $T_PAGE;
 return $T_PAGE;
 }

 function getIcon() 
 {
 global $ICO_PAGE;
 return $ICO_PAGE;
 }

 function _setID($id) {
 $this->page_id = $id;
 }

 function getID() {
 return $this->page_id;
 }
 
 function getPropertyNames()
 {
 return array_merge( parent::getPropertyNames(),
 array("folder"=>i18n("Folder"),
 "description"=>i18n("Description"), 
 "template"=>i18n("Template"), 
 "tags"=>i18n("Tags"),
 "status"=>i18n("Status"), 
 "priority"=>i18n("Priority"), 
 "filename"=>i18n("Filename"), 
 "edittime"=>i18n("Edittime"), 
 "createtime"=>i18n("Creation Time"), 
 "versions"=>i18n("Versions"),
 "languagevariants"=>i18n("languages"),
 ) );
 }
 
 function getTagNames($parentTags = false) {
 global $T_TEMPLATE;
 $this->_initTags();
 $tags = array();
 
 if ($parentTags) {
 $tpl =& NodeFactory::getStaticInstanceOf($T_TEMPLATE, $this->getFieldValue("template_id"));
 $dtags = $tpl->getTagNames();
 foreach ($dtags as $tag=>$edit) {
 $tags[$tag] = false;
 }
 
 }

 $dtags = $this->d_tags->getKeys();
 foreach ($dtags as $tag) {
 $tags[$tag] = true;
 }
 return $tags;
 }

 function &getTag($tagname) {
 global $T_TEMPLATE;

 $this->_initTags();
 if ($this->d_tags->keyExists($tagname)) {
 return $this->d_tags->getByKey($tagname);
 }
 
 
 $tpl =& NodeFactory::getStaticInstanceOf($T_TEMPLATE, $this->getFieldValue("template_id"));
 $tag =& $tpl->getTag($tagname);
 if ($tag !== NULL) return $tag;
 
 return NULL;
 }
 
 function getValueFields() {
 return array("name"=>"text", "description"=>"textarea", "folder_id"=>false, "template_id"=>false, "status"=>false, 
 "priority"=>false, "filename"=>false, "cdate"=>false, "edate"=>false, "content_id"=>false,
 "contentset_id"=>false, "contentgroup_id"=>false, "sync_page_id" => false, "sync_timestamp" => false,
 "channelset_id" => false, "channel_id" => false, "is_master" => false);
 }

 function _getNodeTable() { return "page"; }
 
 function _initTags() {
 global $T_TAG;
 if (!$this->d_tagsInitialized) {
 $coll = new NodeObjectCollection($T_TAG);
 
 $sql = 'SELECT contenttag.id, contenttag.construct_id, contenttag.name FROM contenttag, page WHERE contenttag.content_id = page.content_id AND page.id ='.sqlf_tl_num($this->getID());
 $rs = query( $sql, true);
 foreach ( $rs["arr"] as $value )
 {
 unset ($o_tag);
 $o_tag = new CNContentTagObject( $value['id'] );
 $o_tag->initFromResultSet( $value );
 $o_tag->setMother($this);
 $coll->add( $o_tag );
 }
 $this->d_tags = &$coll;
 $this->d_tagsInitialized = true;
 }
 }

 function isVersionable () {
 return true;
 }

 function getValueVersion( ) {
 $v = new SQLTableVersion;
 $v->setTable("value");
 $v->setJoin("contenttag","contenttag.id","contenttag_id");
 $v->setWhere("contenttag.content_id = ".sqlf_tl_num($this->getFieldValue("content_id")));
 return $v;
 }
 function getContenttagVersion( ) {
 $v2 = new SQLTableVersion;
 $v2->setTable("contenttag");
 $v2->setJoin("content","content.id","content_id");
 $v2->setWhere("content.id = ".sqlf_tl_num($this->getFieldValue("content_id")));
 return $v2;
 }
 function getDSVersion( ) {
 $v3 = new SQLTableVersion;
 $v3->setTable("ds");
 $v3->setJoin("contenttag","contenttag.id","contenttag_id");
 $v3->setWhere("contenttag.content_id = ".sqlf_tl_num($this->getFieldValue("content_id")));
 return $v3;
 }
 function getDSObjVersion( ) {
 $v4 = new SQLTableVersion;
 $v4->setTable("ds_obj");
 $v4->setJoin("contenttag","contenttag.id","contenttag_id");
 $v4->setWhere("contenttag.content_id = ".sqlf_tl_num($this->getFieldValue("content_id")));
 return $v4;
 }
 function getPageVersion() {
 $v = new SQLTableVersion;
 $v->setTable("page");
 $v->setWhere("page.id = ".sqlf_tl_num($this->getID()));
 return $v;
 }

 





 function restore($date, $createVersion = false, $createPreVersion = true) {
 global $W_RESTORE, $T_PAGE, $TIME, $USER_ID, $CN_LOCAL_SERVER, $PORTLETAPP_PREFIX_INTERNAL, $SESSION_TOKEN;

 
 $fc = new fetchCurl();
 $url = $CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/page/restore/".$this->getID()."?sid=$SESSION_TOKEN&version=$date";
 $fc->setUrl($url);
 $fc->setSubmitType("POST");
 $fc->setPostData("{}");
 $fc->setHeader("Content-Type", "application/json");
 $json = $fc->doRequest();

 
 if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp for restoring page version.');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
 }

 return true;
 }

 




 function restoreTag($date, $tag) {
 global $CN_LOCAL_SERVER, $PORTLETAPP_PREFIX_INTERNAL, $SESSION_TOKEN;

 $fc = new fetchCurl();
 $url = $CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/page/restore/".$this->getID()."/".$tag."?sid=$SESSION_TOKEN&version=$date";
 $fc->setUrl($url);
 $fc->setSubmitType("POST");
 $fc->setPostData("{}");
 $fc->setHeader("Content-Type", "application/json");
 $json = $fc->doRequest();

 
 if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp for restoring page version.');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
 }

 return true;
 }

 function createVersion($time,$userid,$diff = false, $publishedVersion = false) {
 global $T_PAGE, $CN_LOCAL_SERVER, $PORTLETAPP_PREFIX_INTERNAL, $SESSION_TOKEN;

 if (!$diff && !$publishedVersion) {
 $fc = new fetchCurl();
 $url = $CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/page/save/".$this->getID()."?sid=$SESSION_TOKEN";
 $fc->setUrl($url);
 $fc->setSubmitType("POST");
 $fc->setPostData("{\"page\":{\"id\":".$this->getID()."}}");
 $fc->setHeader("Content-Type", "application/json");
 $json = $fc->doRequest();

 
 if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp for creating page version.');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
 }

 return true;
 }

 
 $nextversionnumber = $publishedVersion ? "1.0" : "0.1";

 
 $nextupdateversionnumber = $nextversionnumber;

 
 $versions = $this->getVersions();
 if ($versions && $versions->size() > 0) { 
 $lastversion = $versions->get($versions->size() - 1);
 $parts = explode(".", $lastversion->d_version);
 if ($publishedVersion) {
 $nextversionnumber = ($parts[0] + 1).".0";
 
 if ($parts[1] == "0") {
 $nextupdateversionnumber = $lastversion->d_version;
 } else {
 $nextupdateversionnumber = $nextversionnumber;
 }
 } else {
 $nextversionnumber = $parts[0].".".($parts[1] + 1);
 $nextupdateversionnumber = $nextversionnumber;
 }
 }

 
 $v = $this->getValueVersion( );
 $ret = $v->createVersion($time,$userid,$diff);

 
 $v = $this->getContenttagVersion();
 $ret2 = $v->createVersion($time,$userid,$diff);

 
 $v = $this->getDSVersion();
 $ret3 = $v->createVersion($time,$userid,$diff);

 
 $v = $this->getDSObjVersion();
 $ret4 = $v->createVersion($time,$userid,$diff);

 
 $v = $this->getPageVersion();
 $ret5 = $v->createVersion($time, $userid, $diff);

 
 if ($ret || $ret2 || $ret3 || $ret4 || $ret5) {
 $sql = "INSERT INTO nodeversion (timestamp,user_id,o_type,o_id, published, nodeversion) VALUES (".sqlf_tl_num($time).",".sqlf_tl_num($userid).",".sqlf_tl_num($T_PAGE).", ".sqlf_tl_num($this->getID()).", ".($publishedVersion ? "1" : "0").", ".sql_str($nextversionnumber).")";
 if (!$diff) {
 query($sql);
 logcmd($publishedVersion ? W_MAJORVERSION : W_VERSION, $T_PAGE, $this->getID(), 0, "created version ".$nextversionnumber);

 if ($publishedVersion) {
 
 $sql = "UPDATE nodeversion SET published = 0 WHERE o_type = ".sqlf_tl_num($T_PAGE)." AND o_id = ".sqlf_tl_num($this->getID())." AND timestamp != ".sqlf_tl_num($time);
 query($sql);
 }
 }
 return true;
 } else {
 if ($publishedVersion) {
 
 if ($lastversion) { 
 $sql = "UPDATE nodeversion SET published = IF(timestamp = ".sqlf_tl_num($lastversion->d_date).", 1, 0), nodeversion = IF(timestamp = ".sqlf_tl_num($lastversion->d_date).", ".sql_str($nextupdateversionnumber).", nodeversion) WHERE o_type = ".sqlf_tl_num($T_PAGE)." AND o_id = ".sqlf_tl_num($this->getID());
 query($sql);
 logcmd(W_MAJORVERSION, $T_PAGE, $this->getID(), 0, "updated version ".$lastversion->d_version." to ".$nextupdateversionnumber);
 }
 }
 return false;
 }
 }

 function deleteAllVersions() {
 
 $v = $this->getValueVersion( );
 $ret = $v->deleteAllVersions();

 
 $v = $this->getContenttagVersion();
 $ret2 = $v->deleteAllVersions();

 
 $v = $this->getDSVersion();
 $ret3 = $v->deleteAllVersions();

 
 $v = $this->getDSObjVersion();
 $ret4 = $v->deleteAllVersions();

 
 $v = $this->getPageVersion();
 $ret5 = $v->deleteAllVersions();

 $sql = "DELETE FROM nodeversion WHERE o_type = 10007 AND o_id = ".sqlf_tl_num($this->getID());
 decho( "Delete Version: ".$sql."<br>", "version" );
 query( $sql );
 }

 
 function deleteOldVersions($time) {
 
 $v = $this->getValueVersion( );
 $v->deleteOldVersions($time);

 
 $v = $this->getDSVersion();
 $v->deleteOldVersions($time);

 
 $v = $this->getDSObjVersion();
 $v->deleteOldVersions($time);

 
 $v = $this->getContenttagVersion();
 $v->deleteOldVersions($time);

 
 $v = $this->getPageVersion();
 $v->deleteOldVersions($time);

 
 
 







 
 $sql = "DELETE FROM nodeversion WHERE o_type = 10007 AND timestamp < ".sqlf_tl_num($time);
 decho (" Delete Versions: ".$sql."<br>","version");
 query($sql);
 }

 function diffVersion($time,$userid) {
 return $this->createVersion($time,$userid,true);
 }
 
 function getVersions() {
 if (!$this->d_versionsInitialized) {
 $this->_initVersions();
 }
 return $this->d_versions;
 }

 function _initVersions() {
 global $T_VERSION, $T_PAGE, $W_PAGEPUB;
 node_include("cmd_desc");
 
 






 $sql = "SELECT id, timestamp, user_id, nodeversion version, published FROM nodeversion".
 " WHERE o_type = ".sqlf_tl_num($T_PAGE)." and o_id = ".sqlf_tl_num($this->getID())." ORDER BY timestamp ASC";
 $rs = query($sql);
 $versions = $rs["arr"];

 $finalversions = Array();

 
 $create_numbers = false;
 reset($versions);
 foreach ($versions as $versionkey=>$version) {
 if (!$version["version"]) {
 $create_numbers = true;
 }
 }

 if ($create_numbers) {
 
 $sql = "SELECT timestamp FROM logcmd WHERE cmd_desc_id = ".sqlf_tl_num($W_PAGEPUB)." AND o_type = ".sqlf_tl_num($T_PAGE)." and o_id = ".sqlf_tl_num($this->getID()).
 " ORDER BY timestamp ASC";
 $rs = query($sql);
 $publishes = $rs["arr"];
 $minorversion = 0;
 $majorversion = 0;
 reset($versions);
 foreach($versions as $versionkey=>$version) {

 $last_majorversion = $majorversion;

 if (count($versions) > $versionkey+1) {
 $nextversion = $versionkey+1;
 } else $nextversion = false;
 reset($publishes);
 foreach($publishes as $publish) {
 if ($publish["timestamp"] >= $version["timestamp"]) {
 if ($versions[$nextversion]["timestamp"] > $publish["timestamp"] || !$nextversion) {
 $majorversion++;
 break;
 }
 }
 }
 
 if ($last_majorversion != $majorversion) {
 $minorversion = 0;
 } else {
 $minorversion++;
 }
 
 $finalversions[$versionkey]["version"] = "$majorversion.$minorversion";
 $finalversions[$versionkey]["timestamp"] = $version["timestamp"];
 $finalversions[$versionkey]["user_id"] = $version["user_id"];
 $finalversions[$versionkey]["published"] = $version["published"];

 
 if ($version["id"]) {
 $sql = "UPDATE nodeversion SET nodeversion = ".sql_str("$majorversion.$minorversion")." WHERE id = ".sqlf_tl_num($version["id"]);
 query($sql);
 }
 }
 } else {
 $finalversions = $versions;
 }

 $coll = new NodeObjectCollection( $T_VERSION );
 foreach($finalversions as $version) {
 $coll->add(new CNVersion(
 array('mother' => $this,
 'date' => $version['timestamp'],
 'userid' => $version['user_id'],
 'version' => $version['version'],
 'publisher' => $version['publisher'],
 'pdate' => $version['pdate'],
 'published' => $version['published'],
 )));
 }

 $this->d_versions = &$coll;
 $this->d_versionsInitialized = true;
 }

 







 function getPublishedVersion() {

 if ( ! $this->d_versionsInitialized ) {
 $this->_initVersions();
 }
 $versions = $this->d_versions;
 
 
 $published = null;
 $major = null;
 $it = $versions->iterator();
 while ($it->hasNext()) {
 $version = $it->next();
 $version_str = $version->getProperty("version");
 list($major, $minor) = explode('.', $version_str->getString());
 
 
 
 
 if ($major && (is_null($published) || $selected_major < $major)) {
 $published = $version;
 $selected_major = $major;
 }
 }

 return $published;
 }

 function &getProperty($key) {
 switch ($key) {
 case "id":
 $class = new StringObject($this->getID());
 break;
 case "name":
 $class = new StringObject($this->getFieldValue("name"));
 break;
 case "description":
 $class = new StringObject($this->getFieldValue("description"));
 break;
 case "folder":
 node_class("cnfolderobject");
 $class = new CNFolderObject($this->getFieldValue("folder_id"));
 break;
 case "node":
 node_class("cnfolderobject");
 $class = new CNFolderObject($this->getFieldValue("folder_id"));
 $class = &$class->getProperty( "node" );
 break;
 case "template":
 $class = new CNTemplateObject($this->getFieldValue("template_id"));
 break;
 case "status":
 $class = new StringObject($this->getFieldValue("status"));
 break;
 case "priority":
 $class = new StringObject($this->getFieldValue("priority"));
 break;
 case "filename":
 $class = new StringObject($this->getFieldValue("filename"));
 break;
 case "edittime":
 $class = new TimeObject($this->getFieldValue("edate"));
 break;
 case "createtime":
 $class = new TimeObject($this->getFieldValue("cdate"));
 break;
 case "content_id":
 $class = new StringObject($this->getFieldValue("content_id"));
 break;
 case "code":
 $class = new StringObject($this->getLanguageCode());
 break;
 case "tags":
 $this->_initTags();
 $class = &$this->d_tags;
 break;
 case "versions":
 $this->_initVersions();
 $class = &$this->d_versions;
 break;
 case "sync_page":
 $class = new CNPageObject($this->getFieldValue("sync_page_id"));
 break;
 case "sync_time":
 $class = new TimeObject($this->getFieldValue("sync_timestamp"));
 break;
 case "sync_timestamp":
 $class = $this->getFieldValue("sync_timestamp");
 break;
 default:
 $class =& parent::getProperty($key);
 }
 return $class;
 }

 function getXML($level = 0, $prefix = '') {
 $this->_initTags();
 $xml = $prefix.'<page>'."\n";
 $xml .= $prefix.'  <id>'. $this->getID().'</id>'."\n";
 $xml .= $prefix.'  <name>'. $this->getFieldValue("name").'</name>'."\n";
 $xml .= $prefix.'  <description>'. $this->getFieldValue("description").'</description>'."\n";
 $xml .= $prefix.'  <filename>'. $this->getFieldName("filename").'</filename>'."\n";
 
 $xml .= $prefix.'  <tags>'."\n";
 $tags =& $this->getProperty("tags");
 $i = $tags->iterator();
 while ($i->hasNext()) {
 $next = $i->next();
 $xml .= $next->getXML($level + 1, $prefix.'  ');
 }
 $xml .= $prefix.'  </tags>'."\n";

 $xml .= $prefix.'</page>'."\n";
 return $xml;
 }

 function getLanguageCode()
 {
 $groups = get_contentgroups();
 return $groups[$this->getFieldValue("contentgroup_id")]["code"];
 }
 
 
 function getLangPageId( $pageId, $contentgroup_id=false )
 {
 static $CACHE = array();
 global $CONTENTGROUP_ID;
 if ( !$contentgroup_id ) $contentgroup_id = $CONTENTGROUP_ID;
 
 if ( !$pageId ) halt( 101, "CNPageObject::getLangPageId: no pageid" ); 
 if ( isset( $CACHE[$pageId][$contentgroup_id] ) )
 return $CACHE[$pageId][$contentgroup_id];

 $sql = "SELECT contentset_id FROM page WHERE id = ".sqlf_tl_num($pageId);
 $rs = query( $sql );
 if ( $rs["num"] == 0 ) halt( 101, "CNPageObject::getLangPageId: invalid page_id($pageId)" );

 $contentset_id = $rs["arr"][0]["contentset_id"];
 $sql = "SELECT id FROM page WHERE contentset_id = ".sqlf_tl_num($contentset_id)." ".
 "AND contentgroup_id = ".sqlf_tl_num($contentgroup_id);
 $rs = query( $sql );
 if ( $rs["num"] == 0 ) {
 $CACHE[$pageId][$contentgroup_id] = $pageId;
 return $pageId;
 }
 $CACHE[$pageId][$contentgroup_id] = $rs["arr"][0]["id"];
 return $rs["arr"][0]["id"];
 }
 
 
 
 
 function dirt( $pageId, $eventType = EVENT_ALL ) {
 triggerEvent(T_PAGE, $pageId, $eventType, new EventObject());
 }
 
 
 function onEventNotify( $TType, $id, $changeType, $linkType, $eventObject, $depth, $simulate ) 
 {
 global $FEATURE, $DEBUG;
 if ($simulate && $simulate > 0) return;
 switch ( $linkType )
 {
 case LINKT_XNL:
 
 
 
 
 
 if ($this->getID()) {
 $sql = "SELECT id FROM page WHERE id = ".sqlf_tl_num($this->getID());
 $rs = query($sql,true);
 if (!$rs["arr"][0]["id"]) {
 warning(7,"invalid page_id in onEventNotify (".$this->getID().")");
 break;
 }
 }
 
 if ($FEATURE["dirt2"]) {
 if ($DEBUG["echo"] && $DEBUG["events"]) echo "dirt single page (".$this->getID().")<br>\n";
 $my = new page_object($this->getID());
 $my->dirt();
 } else {
 warning(7, "Feature dirt2 needed for CNPage::onEventNotify.");
 }
 break; 
 }
 }

 function onStaticEventNotify( $TType, $id, $changeType, $eventObject, $depth, $simulate ) 
 {
 }

 function _checkPermission($parentObjectType, $parentObjectId, $o_type, &$row) {
 global $USER_ID;
 if(perm($USER_ID, T_FOLDER, $this->getFieldValue("folder_id"), 11)) {
 return true;
 }
 foreach( $row['lang'] as $lang ) {
 if( perm($USER_ID, T_FOLDER, $this->getFieldValue("folder_id"), 11, $lang['contentgroup_id'], T_PAGE, 10) ) {
 return true;
 }
 }
 return false;
 }

 function delete() {
 return cmd_page_del(array($this->getID() => true), false, true);
 } 

 function &getVersionInfo($date) {
 $versions = &$this->getProperty("versions");
 $i = &$versions->iterator();
 $old_v = null;
 while ($i->hasNext()) {
 $v = &$i->next();
 $v_date = &$v->getProperty("date");
 if ($v_date->getTimestamp() > $date) {
 return $old_v;
 }
 $old_v = &$v;
 }
 return null;
 }

 






 function initFromResultSet($row, $prefix = "", $initOnly = false) {
 $success = parent::initFromResultSet($row, $prefix, $initOnly);
 if ($success && $row["lang"]) {
 reset($row["lang"]);
 $languagevariants = array();
 foreach ( $row["lang"] as $cgId => $variant ) {
 if ($variant['id'] == $row['id']) {
 $o = $this;
 } else {
 $o =& NodeFactory::getStaticInstanceOf(T_PAGE, $variant['id']);
 if (! $o->isInitialized()) {
 $o->initFromResultSet($variant, $prefix, $initOnly);
 }
 }
 $languagevariants[$cgId] = $o;
 }
 $this->setFieldValue("languagevariants", $languagevariants, $initOnly);
 }
 if ($success) {
 $this->setFieldValue("masterNode", $row["masterNode"], $initOnly);
 }
 return $success;
 }
}

class CNTemplateObject extends CNTagCollection {

 var $template_id;
 var $d_tags;
 var $d_tagsInitialized;

 function CNTemplateObject($id = 0) {
 parent::CNTagCollection();
 $this->setID($id);
 $this->d_tags = NULL;
 $this->setViewLinkParams("do=12003&id=" . $this->getId() . "&TEMPLATE_ID=" . $this->getId());
 }

 function _getSearchTable() {
 return 'template t LEFT JOIN template ON (t.channelset_id = template.channelset_id AND t.channelset_id != 0) OR template.id = t.id INNER JOIN template_folder ON template_folder.template_id = t.id';
 }

 function _getFolderColumn() {
 return "template_folder.folder_id";
 }

 function getTType() {
 global $T_TEMPLATE;
 return $T_TEMPLATE;
 }

 function getIcon() 
 {
 global $ICO_TPL;
 return $ICO_TPL;
 }

 function _setID($id) {
 $this->template_id = $id;
 }

 function getID() {
 return (int) $this->template_id;
 }
 
 function getTagNames($parentTags = false) {
 global $T_TEMPLATE;
 $this->_initTags();
 $tags = array();
 
 if ($parentTags) {
 
 }

 $dtags = $this->d_tags->getKeys();
 foreach ($dtags as $tag) {
 $tags[$tag] = true;
 }
 return $tags;
 }

 function &getTag($tagname) {
 $this->_initTags();
 if ($this->d_tags->keyExists($tagname)) {
 return $this->d_tags->getByKey($tagname);
 }
 
 return NULL;
 }
 
 function getValueFields() {
 return array("name"=>"text", "description"=>"textarea", "folder_id"=>false, "creator"=>false, "editor"=>false, 
 "cdate"=>false, "edate"=>false, "channelset_id" => false, "channel_id" => false, "is_master" => false);
 }

 function _getNodeTable() { return "template"; }
 
 function _initTags() {
 global $T_TAG;
 if (!$this->d_tagsInitialized) {
 $coll = new NodeObjectCollection($T_TAG);
 $sql = 'SELECT id, construct_id, name FROM templatetag WHERE templatetag.template_id = '.sqlf_tl_num($this->getID());
 $rs = query( $sql, true);
 foreach ( $rs["arr"] as $value )
 {
 unset ($o_tag);
 $o_tag = new CNTemplateTagObject( $value['id'] );
 $o_tag->initFromResultSet( $value );
 $o_tag->setMother($this);
 $coll->add( $o_tag );
 }
 $this->d_tags = &$coll;
 $this->d_tagsInitialized = true;
 }
 }

 function getPropertyNames()
 {
 return array_merge( parent::getPropertyNames(),
 array("name"=>i18n("Name"), "folder"=>i18n("Folder"), "tags"=>i18n("Tags") ) );
 }
 
 function &getProperty($key) {
 switch ($key) {
 case "id":
 $class = new IntObject($this->getID());
 break;
 case "name": 
 $class = new StringObject($this->getFieldValue("name"));
 break;
 case "folder":
 node_class("cnfolderobject");
 $class = new CNFolderObject($this->getFieldValue("folder_id"));
 break;
 case "node":
 node_class("cnfolderobject");
 $class = new CNFolderObject($this->getFieldValue("folder_id"));
 $class = &$class->getProperty( "node" );
 break;
 case "tags":
 $this->_initTags();
 $class = $this->d_tags;
 break;
 default:
 $class =& parent::getProperty($key);
 }
 
 return $class;
 }
 
 function _checkPermission($parentObjectType, $parentObjectId) {
 global $USER_ID;
 return perm($USER_ID, T_FOLDER, $parentObjectId, 15);
 }

 function delete() {
 $sql = "SELECT folder_id FROM template_folder WHERE template_id = " . sqlf_tl_num($this->getID());
 $rs = query($sql);
 $folderids = array();
 foreach ($rs["arr"] as $row) {
 $folderids[$row["folder_id"]] = true;
 }
 return template_del(array($this->getID() => true), $folderids);
 }

 








 function searchInObject($objecttype, $objectid, $searchterm=null, $recursive=false, $fulltext=false, $ignoreorder=false) {
 global $FEATURE, $CN_LOCAL_SERVER, $PORTLETAPP_PREFIX_INTERNAL, $SESSION_TOKEN, $NODE_ID;
 if ($FEATURE["multichannelling"]) {
 
 node_include("keymapper");
 $km = new KeyMapper(array(
 "folderId" => "folderid",
 "editor.firstName" => "e_firstname",
 "editor.lastName" => "e_lastname",
 "creator.firstName" => "c_firstname",
 "creator.lastName" => "c_lastname",
 "markupLanguage.name" => "type",
 "channelId" => "channel_id",
 "path" => "folder"
 ));

 return $this->_searchInObjectREST("getTemplates", "templates", $objecttype, $objectid, $km, $searchterm, $recursive);
 } else {
 return CNInFolderObject::searchInObject($objecttype, $objectid, $searchterm, $recursive, $fulltext, $ignoreorder);
 }
 }

 






 function initFromResultSet($row, $prefix = "", $initOnly = false) {
 $retval = parent::initFromResultSet($row, $prefix, $initOnly);
 if ($retval) {
 $this->setFieldValue("masterNode", $row["masterNode"], $initOnly);
 }
 return $retval;
 }
}


?>
