<?

function createfolders($mother_id, $folderlist) {
 global $FOLDER_REGEX_ALLOWED_CHARACTERS;
 
 if (!is_array($folderlist)) {
 $folderlist = array($folderlist);
 }

 
 $sql = "SELECT pub_dir FROM folder WHERE id = ".sqlf_tl_num($mother_id);
 $rs = query($sql);

 $parent_pub_dir = $rs["arr"][0]["pub_dir"];

 reset($folderlist);

 
 reset($folderlist);
 $casemapping = array();
 foreach ($folderlist as $folder) {
 $cn_import_folders[strtolower($folder)] = true;
 
 $casemapping[strtolower($folder)] = $folder;
 }
 ksort($cn_import_folders);
 reset($cn_import_folders);

 
 foreach ($cn_import_folders as $path => $id) {
 if ($id && !is_array($cn_import_folders[strtolower(dirname($path))])) {
 $pub_dir = $parent_pub_dir;
 $folder_id = $mother_id;
 } else {
 
 $path = $casemapping[$path];
 $path_parts = explode("/",$path);
 $folder_name = $path_parts[sizeof($path_parts)-1];

 $parent_id = $cn_import_folders[strtolower(dirname($path))]["id"];
 $pub_dir = $cn_import_folders[strtolower(dirname($path))]["pub_dir"]."/$folder_name/";

 
 $pub_dir = eregi_replace("(/)+","/",$pub_dir);
 
 $pub_dir = preg_replace("/[^$FOLDER_REGEX_ALLOWED_CHARACTERS]/", "_", $pub_dir);
 global $ERROR;
 
 $folder_id = cmd_folder_create($folder_name, $parent_id, $pub_dir, "", "");
 if ($folder_id == false) {
 if ($folder_id = folder_getid($folder_name, $parent_id)) {
 
 
 
 $folderinfo = get_folderinfo($folder_id);
 if ($folderinfo['pub_dir'] != $pub_dir || $folderinfo['name'] != $folder_name) {
 
 cmd_folder_update($folder_id, $folder_name, $pub_dir, $folderinfo['description']);
 }
 } else {
 
 halt(7,"unable to create $folder_name inside of $parent_id ($ERROR)<br>");
 }
 }
 }

 $cn_import_folders[strtolower($path)] = array("id"=>$folder_id, "pub_dir" => $pub_dir);
 }

 return $cn_import_folders;
}

function cleanupfolders($folder_id, $cn_import_folders, $keyed_filelist, $logger, $loglevel, $basedir) {
 global $ERROR;

 
 $sql = "SELECT id, filename, name FROM page WHERE folder_id = ".sqlf_tl_num($folder_id);
 $rs = query($sql);

 foreach ($rs["arr"] as $row) {
 $path = $basedir."/".$row["filename"];

 if ( !$keyed_filelist[strtolower($path)] ) {
 if ($loglevel > 0) {
 $logger->addText(date("H:i:s")." - ");
 $logger->addText("removing page $path", true);
 }
 
 set_time_limit(30);
 if (cmd_page_del( array($row["id"]=>true), false, true, 1000 )) {
 if ($loglevel > 0) {
 $logger->addText(date("H:i:s")." - ");
 $logger->addText("ERROR while removing page $path: $ERROR", true);
 }
 }
 }

 }
 
 
 $sql = "SELECT id, name FROM contentfile WHERE folder_id = ".sqlf_tl_num($folder_id);
 $rs = query($sql);

 foreach ($rs["arr"] as $row) {
 $path = $basedir."/".$row["name"];

 if ( !$keyed_filelist[strtolower($path)] ) {
 if ($loglevel > 0) {
 $logger->addText(date("H:i:s")." - ");
 $logger->addText("removing file $path", true);
 }
 
 set_time_limit(30);
 if (cmd_file_del( $row["id"], 1000 )) {
 if ($loglevel > 0) {
 $logger->addText(date("H:i:s")." - ");
 $logger->addText("ERROR while removing file $path: $ERROR", true);
 }
 }
 }
 }

 
 $sql = "SELECT id, name, pub_dir FROM folder WHERE mother = ".sqlf_tl_num($folder_id);
 $rs = query($sql);

 foreach ($rs["arr"] as $row) {
 
 $path = $basedir."/".$row["name"];
 
 if ( $cn_import_folders[strtolower($path)] ) {
 cleanupfolders($row["id"], $cn_import_folders, $keyed_filelist, $logger, $loglevel, $path);
 } else {
 if ($loglevel > 0) {
 $logger->addText(date("H:i:s")." - ");
 $logger->addText("removing folder $path", true);
 }
 if (cmd_folder_del( $row["id"], 60000 )) {
 if ($loglevel > 0) {
 $logger->addText(date("H:i:s")." - ");
 $logger->addText("ERROR while removing folder $path: $ERROR", true);
 }
 }
 }
 
 }

}

?>
