<?



global $USER_ID, $T_TYPE, $DIC, $ICO_FOLDER, $ICO_FOLDER_CHANNEL, $ICO_FOLDER_CLOSED, $ICO_FOLDER_CHANNEL_CLOSED, $T_DOMAIN, $T_FOLDER, $FEATURE, $T_DOMAIN_CHANNEL, $T_FOLDER_CHANNEL;
global $T_CONTENT, $ICO_CONTENT, $ICO_CONTENT_CLOSED;










function buildRecIdParam(&$displayTypes, &$open, $rootType) {
 $recIds[] = "0";
 $nodes = array();
 $rs = query("SELECT id, folder_id FROM node");
 foreach ( $rs["arr"] as $rec ) {
 $nodes[$rec["folder_id"]] = $rec["id"];
 }

 if (!empty($open)) {
 foreach ( $open as $key => $value ) {
 if ($value !== 1) {
 continue;
 }
 if ($rootType === 0) {
 
 
 
 if (strpos($key, "-1-") === 0) {
 $parts = explode("-", $key);
 $rootId = $parts[2];
 $id = $parts[count($parts) - 1];
 $nodeId = $nodes[$rootId];
 $recIds[] = "$nodeId/$id";
 }
 } else {
 
 
 $parts = explode("-", $key);
 $rootId = $parts[1];
 $id = $parts[count($parts) - 1];
 $nodeId = $nodes[$rootId];
 if ($nodeId) {
 $recIds[] = "$nodeId/$id";
 }
 }
 }
 }

 return $recIds;
}





function remove_type_node(&$folder) {
 return $folder["type"] !== "node";
}





function remove_type_channel(&$folder) {
 return $folder["type"] !== "channel";
}





function remove_type_folder(&$folder) {
 return $folder["type"] !== "folder";
}









function recursive_build_tree($mother, $folders, $nodeId, &$visible, $hasSubfolders = true) {
 global $TREEFOLDERS;

 if (!is_array($folders)) {
 $folders = array();
 if ($hasSubfolders) {
 $folders[] = array("id" => 0, "type_id" => $GLOBALS["T_FOLDER"], "master_id" => 0);
 }
 } else {
 if (!in_array("node", $visible)) {
 $folders = array_filter($folders, "remove_type_node");
 }
 if (!in_array("channel", $visible)) {
 $folders = array_filter($folders, "remove_type_channel");
 }
 if (!in_array("folder", $visible)) {
 $folders = array_filter($folders, "remove_type_folder");
 }
 foreach ( $folders as &$folder ) {
 $folder["node_id"] = $folder["nodeId"];
 switch ($folder["type"]) {
 case "folder":
 $folder["type_id"] = $folder["inherited"] ? $GLOBALS["T_FOLDER_CHANNEL"] : $GLOBALS["T_FOLDER"];
 break;
 case "node":
 $folder["type_id"] = $GLOBALS["T_DOMAIN"];
 break;
 case "channel":
 $folder["type_id"] = $GLOBALS["T_DOMAIN_CHANNEL"];
 $rs = query("select mfolder.name from folder, folder mfolder where folder.master_id = mfolder.id and folder.id = ".sqlf_tl_num($folder["id"]));
 if ($rs["num"] > 0) {
 $folder["name"] .= "  (&rarr; ".$rs["arr"][0]["name"].")";
 }
 break;
 }
 $folder["master_id"] = $folder["masterId"];
 if ($folder["master_id"] == 0) {
 $folder["master_id"] = $folder["id"];
 }
 
 $GLOBALS["REST_PERM_CACHE"][$GLOBALS["T_FOLDER"]."|".$folder["id"]."|".$folder["nodeId"]] = $folder["privilegeBits"];
 $GLOBALS["REST_PERM_CACHE"][$GLOBALS["T_DOMAIN"]."|".$folder["id"]."|".$folder["nodeId"]] = $folder["privilegeBits"];

 recursive_build_tree($folder["id"], $folder["subfolders"], $folder["nodeId"], $visible, $folder["hasSubfolders"]);
 unset($folder["subfolders"]);
 }
 }

 $TREEFOLDERS[$nodeId][$mother] = $folders;
}











function tree_get_nodes_rest($displayTypes, $open, $rootType, $t_type) {
 global $TREEFOLDERS, $T_CONTENT;

 $isRecursive = false;
 if (in_array("folder", $t_type[$T_CONTENT]["visible"])) {
 $isRecursive = true;
 }

 $url = $GLOBALS["CN_LOCAL_SERVER"].$GLOBALS["PORTLETAPP_PREFIX_INTERNAL"]."rest/folder/getFolders?sid=".$GLOBALS["SESSION_TOKEN"];
 $recursiveIds = buildRecIdParam($displayTypes, $open, $rootType);
 $encondedJSONData = json_encode(array(
 'id' => '0',
 'recursiveIds' => $recursiveIds,
 'recursive' => $isRecursive,
 'tree' => true,
 'addPrivileges' => true
 ));

 $fc = new fetchCurl("POST");
 $fc->setUrl($url);
 $fc->setHeader("Content-Type", "application/json; charset=UTF8");
 $fc->setPostData($encondedJSONData);

 $json = $fc->doRequest();

 
 if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp.');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
 }

 $folders = json_decode($json,true);
 $folders = $folders["folders"];

 recursive_build_tree(0, $folders, 0, $t_type[$T_CONTENT]["visible"]);

 return $TREEFOLDERS[0][0];
}






function tree_get_folders_rest($nid, $nodeId=0) {
 global $TREEFOLDERS;

 if (!$nodeId) {
 $folderinfo = get_folderinfo($nid);
 $nodeId = $folderinfo["node_id"];
 }

 return $TREEFOLDERS[$nodeId][$nid];
}

function tree_fetchmap( $nid, $type_id )
{
 global $T_MAP_ENTRY, $USER_ID, $T_MAP, $USER_ID;
 node_class( "cnmapobject" );
 $sql = "SELECT DISTINCT id, mother_id, name, ".sqlf_tl_num($type_id)." AS type_id, node_id, LOWER(name) AS l_name ".
 "FROM cn_map ".
 "WHERE cn_map.mother_id = ".sqlf_tl_num($nid)." ".
 "ORDER BY l_name";
 $rs = query ( $sql );
 $ret = array();
 foreach ( $rs["arr"] as $key=>$row )
 {
 if ( $row["mother_id"] != 0 ){
 if ( perm( $USER_ID, $T_MAP_ENTRY, $row["id"], 0 ) )
 {
 $name = CNMapEntryObject::getMapName( $row["id"], $row["node_id"] );
 $rs["arr"][$key]["name"] = $name;
 $ret[] = $rs["arr"][$key];
 }
 } else {
 if ( perm( $USER_ID, $T_MAP, $row["id"], 0 ) )
 $ret[] = $rs["arr"][$key];
 }
 }
 return $ret; 
}


global $NODE_FUNCTION;
$NODE_FUNCTION["tree_fetchmap"] = FALSE; 
$NODE_FUNCTION["tree_get_folders_rest"] = FALSE;
$NODE_FUNCTION["tree_get_nodes_rest"] = FALSE;

$T_TYPE[$T_CONTENT]=array(
 "name" =>i18n('content.node'),
 "object" =>false,
 
 "self_i18n" =>i18n('content.node'),
 "fkt" => 'node_func( \"tree_get_nodes_rest\", TRUE, \$displayTypes, \$open, \$rootType, \$t_type )',
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 "link" =>"do=11012",
 "linkvar" =>"id",
 "linktarget" =>"list",
 "allowlink" =>"node_func(\"perm\", true, ".evalf_num($USER_ID).",".evalf_num($T_CONTENT).",0,8)",
 "append" =>"</b>",
 "prepend" =>"<b>",
 "folderopen" =>evalf_string_dq($ICO_CONTENT),
 "folderclosed" =>evalf_string_dq($ICO_CONTENT_CLOSED),
 "visible" => array("node", "channel", "folder")
 );

global $T_CONADMIN, $ICO_CONADMIN;
$T_TYPE[$T_CONADMIN]=array(
 "name" =>i18n('menu_content.node'),
 "object" =>false,
 
 "self_i18n" =>i18n('cn_content_admin'),
 
 
 "fkt" =>"tree_i18n(\$nid)",
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 "linkvar" =>"",
 "linktarget" =>"main",
 "allowlink" =>false,
 "append" =>"",
 "prepend" =>"",
 "folderopen" =>evalf_string_dq($ICO_CONADMIN),
 "folderclosed" =>evalf_string_dq($ICO_CONADMIN)
 );

global $ICO_DOMAIN;
$T_TYPE[$T_DOMAIN] = array(
 "name" =>i18n('401.node'),
 "object" =>true,
 "self" =>"SELECT name FROM folder WHERE id=",
 "fkt" => 'node_func( \"tree_get_folders_rest\", TRUE, \$nid, null, \$open )',
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 
 "link" =>"do=13020&NODE_ID={\$rowval['node_id']}",
 "linkvar" =>"FOLDER_ID",
 "linktarget" =>"list",
 "allowlink" =>true,
 "append" =>"",
 "prepend" =>"",
 "folderopen" =>evalf_string_dq($ICO_DOMAIN),
 "folderclosed" =>evalf_string_dq($ICO_DOMAIN),
 "use_perm" =>$T_FOLDER,
 "use_perm_sql" =>"SELECT id FROM folder WHERE id = ",
 "context" =>"node_func(\"get_node_context_menu\", true, \$nid, \$nmother, \$ntype )"
 );

global $ICO_DOMAIN_CHANNEL;
$T_TYPE[$T_DOMAIN_CHANNEL] = array(
 "name" =>i18n('401.node'),
 "object" =>true,
 "self" =>"SELECT name FROM folder WHERE id=",
 "fkt" => 'node_func( \"tree_get_folders_rest\", TRUE, \$nid, null, \$open )',
 "ntype" => "type_id",
 "nid" =>"id",
 "nname" =>"name",
 
 "link" =>"do=13020&NODE_ID={\$rowval['node_id']}",
 "linkvar" =>"FOLDER_ID",
 "linktarget" =>"list",
 "childvals" => array("node_id" => "{\$rowval['node_id']}"),
 "allowlink" =>true,
 "append" =>"",
 "prepend" =>"",
 "folderopen" =>evalf_string_dq($ICO_DOMAIN_CHANNEL),
 "folderclosed" =>evalf_string_dq($ICO_DOMAIN_CHANNEL),
 "use_perm" =>$T_FOLDER,
 "use_perm_sql" =>"SELECT id FROM folder WHERE id = ",
 "context" =>"node_func(\"get_node_context_menu\", true, \$nid, \$nmother, \$ntype )"
 );


$T_TYPE[$T_FOLDER] = array(
 "name" =>i18n('402.folder'),
 "key" =>"object",
 "object" =>true,
 "fkt" => 'node_func( \"tree_get_folders_rest\", TRUE, \$nid, {$rowval["node_id"]}, \$open )',
 "self" =>"SELECT name FROM folder WHERE id=",
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 "link" =>"do=13020&NODE_ID={\$rowval['node_id']}",
 "linkvar" =>"FOLDER_ID",
 "linktarget" =>"list",
 "childvals" => array("node_id" => "{\$rowval['node_id']}"),
 "allowlink" =>true,
 "append" =>"",
 "prepend" =>"",
 "folderopen" =>evalf_string_dq($ICO_FOLDER),
 "folderclosed" =>evalf_string_dq($ICO_FOLDER_CLOSED),
 "context" =>"node_func(\"get_folder_context_menu\", true, \$nid, \$nmother, \$ntype, \$rowval['node_id'] )",
 "parentfkt" =>"node_func(\\\"get_folder_parent\\\", true, \$ntype, \$nid )"
 );


$T_TYPE[$T_FOLDER_CHANNEL] = array(
 "name" =>i18n('402.folder'),
 "key" =>"object",
 "object" =>true,
 "fkt" => 'node_func( \"tree_get_folders_rest\", TRUE, \$nid, {$rowval["node_id"]}, \$open )',
 "self" =>"SELECT name FROM folder WHERE id=",
 "ntype" => "type_id",
 "nid" =>"id",
 "nname" =>"name",
 "link" =>"do=13020&NODE_ID={\$rowval['node_id']}",
 "linkvar" =>"FOLDER_ID",
 "linktarget" =>"list",
 "childvals" => array("node_id" => "{\$rowval['node_id']}"),
 "allowlink" =>true,
 "append" =>"",
 "prepend" =>"",
 "folderopen" =>evalf_string_dq($ICO_FOLDER_CHANNEL),
 "folderclosed" =>evalf_string_dq($ICO_FOLDER_CHANNEL_CLOSED),
 "context" =>"node_func(\"get_folder_context_menu\", true, \$nid, \$nmother, \$ntype, \$rowval['node_id'] )",
 "parentfkt" =>"node_func(\\\"get_folder_parent\\\", true, \$ntype, \$nid )"
 );

global $T_CONSTRUCTS, $ICO_CONSTRUCT;

$T_TYPE[$T_CONSTRUCTS] = array(
 "name" =>i18n('tagtype'),
 "object" =>false,
 
 "self_i18n" =>i18n('tagtype'),
 "link" =>"do=10001",
 "linktarget" =>"list",
 "linkvar" =>"treemenu",
 "allowlink" =>true,
 "folderopen" =>evalf_string_dq($ICO_CONSTRUCT),
 "folderclosed"=>evalf_string_dq($ICO_CONSTRUCT),
 "fkt" =>"tree_i18n(\$nid)",
 "nid" => 'id',
 "ntype" =>"type_id",
 "nname" =>"name",
);

global $T_CONSTRUCT, $ICO_CONSTRUCT, $LANGUAGE, $SQLAS;

$T_TYPE[$T_CONSTRUCT] = array(
 "name" =>i18n( "Construct" ),
 "object" =>true,
 
 
 "self" => "SELECT dicuser.value AS name FROM construct, dicuser, dicuser $SQLAS dicd ".
 "WHERE construct.name_id = dicuser.output_id AND dicuser.language_id = ".sqlf_tl_num($LANGUAGE)." ".
 "AND dicd.output_id = construct.description_id AND dicd.language_id = ".sqlf_tl_num($LANGUAGE)." ".
 "AND construct.id = ",
 "link" =>"do=10001",
 "linktarget" =>"list",
 "linkvar" =>"treemenu",
 "allowlink" =>true,
 "folderopen" =>evalf_string_dq($ICO_CONSTRUCT),
 "folderclosed"=>evalf_string_dq($ICO_CONSTRUCT),
);


global $T_TAGADMIN, $ICO_TAG;

$T_TYPE[$T_TAGADMIN] = array(
 "name" =>i18n('menu_tag'),
 "object" =>false,
 
 "self_i18n" =>i18n('tag'),
 "link" =>"do=10005",
 "linkvar" =>"treemenu",
 "linktarget" =>"list",
 "allowlink" =>true,
 "folderopen" =>evalf_string_dq($ICO_TAG),
 "folderclosed"=>evalf_string_dq($ICO_TAG)
);

global $ICO_JAVAADMIN, $T_JAVAADMIN;
$T_TYPE[$T_JAVAADMIN] = array(
 "name" =>i18n("Java.Admin"),
 "object" =>false,
 "self_i18n" =>i18n("Java.Admin"),
 "link" =>"do=15400",
 "linktarget"=>"list",
 "linkvar" =>"treemenu",
 "allowlink" =>true,
 "folderopen"=>evalf_string_dq($ICO_JAVAADMIN),
 "folderclosed"=>evalf_string_dq($ICO_JAVAADMIN)
); 

global $ICO_STATISTIC, $T_STATISTIC;
$T_TYPE[$T_STATISTIC] = array(
 "name" =>i18n('cn_statistic'),
 "object" =>false,
 
 "self_i18n" =>i18n('cn_statistic'),
 "link" =>"do=15104",
 "linkvar" =>"treemenu",
 "linktarget" =>"list",
 "allowlink" =>true,
 "folderopen" =>evalf_string_dq($ICO_STATISTIC),
 "folderclosed"=>evalf_string_dq($ICO_STATISTIC)
);

global $T_TEMPLATE, $ICO_TPL;
$T_TYPE[$T_TEMPLATE] = array(
 "name" =>i18n("Template"),
 "object" =>true,
 "key" =>"object",
 "folderopen" =>evalf_string_dq($ICO_TPL),
 "folderclosed"=>evalf_string_dq($ICO_TPL),
 "self" =>"SELECT name FROM template WHERE id = "
);

global $T_PAGE, $ICO_PAGE;
$T_TYPE[$T_PAGE] = array(
 "name" =>i18n("Page"),
 "object" =>true,
 "folderopen" =>evalf_string_dq($ICO_PAGE),
 "folderclosed"=>evalf_string_dq($ICO_PAGE),
 "self" =>"SELECT name FROM page WHERE id = ",
 "key" =>"object",
 "link" => "do=14001",
 "linkvar" => "PAGE_ID"
);

global $T_PAGELANGUAGE, $ICO_PAGELANGUAGE;
$T_TYPE[$T_PAGELANGUAGE] = array(
 "name" =>i18n('language'),
 "object" =>true,
 "self" =>"SELECT name FROM page WHERE id = ",
 "key" =>"object",
 "linktarget" =>"list",
 "link" =>"do=14201",
 
 "self_i18n" =>i18n('languages'),
 "allowlink" =>true,
 "folderopen" =>evalf_string_dq($ICO_PAGELANGUAGE),
 "folderclosed" =>evalf_string_dq($ICO_PAGELANGUAGE)
);

global $T_FILE, $ICO_FILE;
$T_TYPE[$T_FILE] = array(
 "name" =>i18n("File"),
 "object" =>true,
 "folderopen" =>evalf_string_dq($ICO_FILE),
 "folderclosed"=>evalf_string_dq($ICO_FILE),
 "key" =>"object",
 "self" =>"SELECT name FROM contentfile WHERE id = "
);

global $T_TAG, $ICO_TAG;
$T_TYPE[$T_TAG] = array(
 "name" =>i18n('tag'),
 "object" =>false,
 "folderopen" =>evalf_string_dq($ICO_TAG),
 "self" =>"SELECT name FROM globaltag WHERE id = "
);

global $T_IMAGE, $ICO_IMG;
$T_TYPE[$T_IMAGE] = array(
 "name" =>i18n("Image"),
 "object" =>true,
 "folderopen" =>evalf_string_dq($ICO_IMG),
 "folderclosed"=>evalf_string_dq($ICO_IMG),
 "self" =>"SELECT name FROM contentfile WHERE id = ",
 "key" =>"object"
);

global $T_QUEUE, $ICO_PUBQUEUE;
$T_TYPE[$T_QUEUE] = array(
 "name" =>i18n('queue'),
 "object" =>false,
 "linktarget" =>"list",
 "allowlink" =>true,
 "folderopen" =>evalf_string_dq($ICO_PUBQUEUE),
 "folderclosed" =>evalf_string_dq($ICO_PUBQUEUE),
 "link" =>"do=16001"
);

global $T_PUBQUEUE;
$T_TYPE[$T_PUBQUEUE] = array(
 "name" =>i18n('918.queue'),
 "object" =>false,
 "linktarget" =>"list",
 "allowlink" =>true,
 "folderopen" =>evalf_string_dq($ICO_PUBQUEUE),
 "folderclosed" =>evalf_string_dq($ICO_PUBQUEUE),
 "link" =>"do=16003",
 
 "self_i18n" =>i18n('918.queue')
);

global $T_FAQ, $ICO_FAQ;
$T_TYPE[$T_FAQ] = array(
 "name" =>i18n('cn_faq'),
 "object" =>false,
 "linktarget" =>"list",
 "allowlink" =>true,
 "folderopen" =>evalf_string_dq($ICO_FAQ),
 "folderclosed" =>evalf_string_dq($ICO_FAQ),
 "link" =>"do=18001&reset=1",
 
 "self_i18n" =>i18n('cn_faq')
);

global $T_CONTENTMAP_BROWSER, $ICO_CONTENTMAP;
$T_TYPE[$T_CONTENTMAP_BROWSER] = array(
 "name" =>i18n( "Contentmap Browser" ),
 "object" =>false,
 "linktarget" =>"list",
 "allowlink" =>true,
 "folderopen" =>evalf_string_dq($ICO_CONTENTMAP),
 "folderclosed" =>evalf_string_dq($ICO_CONTENTMAP),
 "link" =>"do=15203&type=contentmap",
 "self_i18n" =>i18n( "Contentmap Browser" )
);
global $T_TAGMAP_EDITOR, $ICO_CONTENTMAP_TAGMAP;
$T_TYPE[$T_TAGMAP_EDITOR] = array(
 "name" =>i18n( "Tagmap Editor" ),
 "object" =>false,
 "linktarget" =>"list",
 "allowlink" =>true,
 "folderopen" =>evalf_string_dq($ICO_CONTENTMAP_TAGMAP),
 "folderclosed" =>evalf_string_dq($ICO_CONTENTMAP_TAGMAP),
 "link" =>"do=15200&type=tagmap&treeclick=1",
 "self_i18n" =>i18n( "Tagmap Editor" )
);

global $T_SOURCE, $ICO_SOURCE;
$T_TYPE[$T_SOURCE] = array(
 "name" =>i18n( "Datasources" ),
 
 "object" =>false,
 "link" =>"do=19101",
 "linktarget" =>"list",
 "self" =>"SELECT name FROM datasource WHERE id=",
 "self_i18n" =>i18n( "Datasources" ),
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 "allowlink" =>true,
 "folderopen" =>evalf_string_dq($ICO_SOURCE),
 "folderclosed" =>evalf_string_dq($ICO_SOURCE),
 ); 

if ($FEATURE["datasource_perm"]) {
 $T_TYPE[$T_SOURCE]["permsql"] = "SELECT id, name, " . sqlf_tl_num_eval_dq(T_DATASOURCE) . 
 " as type_id FROM datasource WHERE name != '' ORDER by name";
}

$T_TYPE[T_DATASOURCE] = array(
 "name" => i18n("Datasource"),
 "self" => "SELECT name FROM datasource WHERE id = ",
 "sql" => "SELECT \$nid as id, ".sqlf_tl_num_eval_dq(T_DATASOURCE_ELEMENT)." as type_id, '" . sqlf_escaped_eval_dq(i18n("Values")) . "' as name",
 "ntype" => "type_id",
 "nid" => "id",
 "nname" => "name",
 "folderopen" =>evalf_string_dq($ICO_SOURCE),
 "folderclosed" =>evalf_string_dq($ICO_SOURCE),
);

global $T_MAPS, $ICO_MAPS;
$T_TYPE[$T_MAPS]=array(
 "name" =>i18n('cn_maps'),
 "object" =>false,
 "link" =>"do=19002",
 "linktarget" =>"list",
 
 "self_i18n" =>i18n('cn_maps'),
 
 
 
 "fkt" =>'node_func( \"tree_fetchmap\", TRUE, 0, '.evalf_num($T_MAP).' )', 
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 "allowlink" =>true,
 "folderopen" =>evalf_string_dq($ICO_MAPS),
 "folderclosed" =>evalf_string_dq($ICO_MAPS)
 );


global $T_MAP, $ICO_MAP, $T_MAP_ENTRY;
$T_TYPE[$T_MAP]=array(
 "name" =>i18n('cn_map'),
 "object" =>false,
 "self" =>"SELECT name FROM cn_map WHERE id=",
 "fkt" =>'node_func( \"tree_fetchmap\", TRUE, $nid, '.evalf_num($T_MAP_ENTRY).' )',

 "nid" =>"id",
 "nname" =>"name",
 "link" =>"do=19004",
 "linkvar" =>"MAP_ID",
 "linktarget" =>"list",
 "allowlink" =>true,
 "folderopen" =>evalf_string_dq($ICO_MAP),
 "folderclosed" =>evalf_string_dq($ICO_MAP)
 );

global $ICO_MAP_ENTRY;
$T_TYPE[$T_MAP_ENTRY]=array(
 "name" =>i18n('cn_mapentry'),
 "object" =>false,

 "self_fkt" => 'node_func( "mapobject_getmapname", TRUE, $nid, $node_id )',

 "fkt" =>'node_func( \"tree_fetchmap\", TRUE, $nid, '.evalf_num($T_MAP_ENTRY).' )',
 "ntype" =>"type_id",
 "nid" =>"id",
 "nname" =>"name",
 "link" =>"cmd=update&do=19003",
 "linkvar" =>"MAP_ENTRY_ID",
 "linktarget" =>"list",
 "allowlink" =>true,
 "folderopen" =>evalf_string_dq($ICO_MAP_ENTRY),
 "folderclosed" =>evalf_string_dq($ICO_MAP_ENTRY)
 );

global $T_MAINTENANCE, $ICO_MAINTENANCE;
 $T_TYPE[$T_MAINTENANCE] = array(
 "name" => i18n( "maintenance" ),
 "self_i18n" => i18n( "maintenance" ),
 "object" => false,
 "linktarget" => "list",
 "allowlink" => true,
 "folderopen" => evalf_string_dq($ICO_MAINTENANCE),
 "folderclosed" => evalf_string_dq($ICO_MAINTENANCE),
 "link" => "do=16678"
);

if( $FEATURE['construct_categories'] ) {
 $T_TYPE[T_CONSTRUCT_CATEGORIES] = array(
 'name' => i18n( 'Construct Categories' ),
 'self_i18n' => i18n( 'Construct Categories' ),
 'permsql' => "select cc.id, du.value name, " . sqlf_tl_num_eval_dq(T_CONSTRUCT_CATEGORY) ." type_id from construct_category cc left join dicuser du on cc.name_id = du.output_id where du.language_id = ".sqlf_tl_num($LANGUAGE)." ORDER BY cc.sortorder ASC",
 "ntype" => "type_id",
 "nid" => "id",
 "nname" => "name",
 'linktarget' => 'list',
 'object' => false,
 'allowlink' => true,
 'link' => 'do=10016',
 'folderopen' => evalf_string_dq($ICO_CONSTRUCT),
 'folderclosed' => evalf_string_dq($ICO_CONSTRUCT),
 );

 $T_TYPE[T_CONSTRUCT_CATEGORY] = array(
 "name" => i18n("construct_category"),
 "key" => "object",
 "self" => "SELECT cc.id id, du.value name, " . sqlf_tl_num_eval_dq(T_CONSTRUCT_CATEGORY) ." type_id FROM construct_category cc LEFT JOIN dicuser du ON cc.name_id = du.output_id WHERE du.language_id = ".sqlf_tl_num($LANGUAGE)." AND cc.id = ",
 "object" => true,
 "ntype" => "type_id",
 "nid" => "id",
 "nname" => "name",
 "link" => false,
 "self_i18n" => i18n( "construct_category" ),
 "allowlink" => true,
 "folderopen" => evalf_string_dq($ICO_CONSTRUCT),
 "folderclosed" => evalf_string_dq($ICO_CONSTRUCT)
 );
}

global $ICO_CONTENTREPOSITORY;
$T_TYPE[T_TAGMAP_ENTRY] = array(
 "name" =>i18n("Tagmap Entries"),
 "object" =>true,
 "key" =>"object",
 "self" =>"SELECT mapname FROM tagmap WHERE id = ",
 "folderclosed"=>evalf_string_dq($ICO_CONTENTREPOSITORY)
);

global $ICO_CONTENTREPOSITORIES;
$T_TYPE[T_CONTENTREPOSITORIES] = array(
 "name" => i18n( "ContentRepositories" ),
 
 "permsql" => "SELECT id, name, " . sqlf_tl_num_eval_dq(T_CONTENTREPOSITORY) ." as type_id FROM contentrepository WHERE name != '' ORDER by name",
 "ntype" => "type_id",
 "nid" => "id",
 "nname" => "name",
 "object" => false,
 "link" => "do=15210",
 "linktarget" => "list",
 "self_i18n" => i18n( "ContentRepositories" ),
 "allowlink" => true,
 "folderopen" => evalf_string_dq($ICO_CONTENTREPOSITORIES),
 "folderclosed" => evalf_string_dq($ICO_CONTENTREPOSITORIES)
 );

$T_TYPE[T_CONTENTREPOSITORY] = array(
 "name" => i18n("ContentRepository"),
 "key" => "object",
 "self" => "SELECT name FROM contentrepository WHERE id = ",
 "object" => true,
 "ntype" => "type_id",
 "nid" => "id",
 "nname" => "name",
 "link" => "do=15211",
 "linktarget" => "list",
 "linkvar" => "id",
 "self_i18n" => i18n( "ContentRepository" ),
 "allowlink" => true,
 "folderopen" => evalf_string_dq($ICO_CONTENTREPOSITORY),
 "folderclosed" => evalf_string_dq($ICO_CONTENTREPOSITORY)
);
 ?>