<?

GUIFactory::setMainGUI("main");
mysession_var_reg("BUNDLE_ID");


node_class("htmlformwizard");

class DeleteBuilder extends WizardBuilder {

 function updateStep(&$wizard, $stepNr, &$form) {
 if($stepNr == 2) {
 $step1 = $wizard->getStep(1);
 $deloption = &$step1->resolveComponent('deloption');
 $delo = $deloption->getSingleSelection();
 $lbl_discard = &$form->resolveComponent('lbl_discard');
 $lbl_uninstall = &$form->resolveComponent('lbl_uninstall');
 $contained_uninstall = &$form->resolveComponent('contained');
 if ($delo == 'discard') {
 $lbl_discard->setVisible(true);
 $lbl_uninstall->setVisible(false);
 $contained_uninstall->setVisible(false);
 } else {
 $lbl_discard->setVisible(false);
 $lbl_uninstall->setVisible(true);
 $contained_uninstall->setVisible(true);
 }
 }
 }

 function createStep(&$wizard, $stepNr, &$form) {
 node_class('labelcomponent');
 node_class('radiolistcomponent');
 if ($stepNr == 1) {
 $deloption = new RadioListComponent(i18n("Delete options"));
 $deloption->setOption('discard', i18n('Only delete import.'));
 $deloption->setOption('uninstall', i18n('Delete import and select contained objects to delete in next step.'));

 $form->addComponent('deloption', $deloption);
 } else if($stepNr == 2) {
 $step1 = $wizard->getStep(1);
 $deloption = &$step1->resolveComponent('deloption');
 $delo = $deloption->getSingleSelection();
 $form->addComponent('lbl_discard', new LabelComponent(null, i18n("Press finish to delete import. All contained objects will remain in the system.")));
 $form->addComponent('lbl_uninstall', new LabelComponent(null, i18n("Select all objects you want to delete."), true));
 
 $form->addComponent('contained', createContainedObjectList(false, true, null, true, true));
 $wizard->lastStep();
 $this->updateStep($wizard, $stepNr, $form);
 }
 }

 function done(&$wizard) {
 global $BUNDLE_ID, $REDO;

 $step1 = $wizard->getStep(1);
 $deloption = &$step1->resolveComponent('deloption');
 $delo = $deloption->getSingleSelection();
 
 if( $delo == 'discard' ) {
 $bundle = &NodeFactory::getStaticInstanceOf(T_BUNDLE, $BUNDLE_ID);
 $bundle->delete();
 $BUNDLE_ID = 0;
 } else if ( $delo == 'uninstall' ) {
 
 $step2 = &$wizard->getStep(2);
 $list = &$step2->resolveComponent('contained.list');
 $ds = &$list->getDatasource();
 $objects = &$ds->getItems();
 usort($objects, sort_by_type2);
 foreach ($objects as $object) {
 
 if ($object["action"] == i18n("delete")) {
 $obj_id = $object["obj_id"];
 $obj_type = $object["obj_type"];
 $nodeobject = &NodeFactory::getStaticInstanceOf($obj_type, $obj_id);
 $success = $nodeobject->delete();
 }
 }
 
 $bundle = &NodeFactory::getStaticInstanceOf(T_BUNDLE, $BUNDLE_ID);
 $bundle->delete();
 $BUNDLE_ID = 0;
 }
 $REDO = 1010;
 }
 function cancel() {
 global $REDO;
 $REDO = 1010;
 }
}


$form = new HtmlFormWizard("deletewizard");
if ($form->isNew()) {
 $deleteBuilder = new DeleteBuilder();
 $form->setBuilder($deleteBuilder);
 $bundle =& NodeFactory::getStaticInstanceOf(T_BUNDLE, $BUNDLE_ID);
 $form->setHeader(i18n("Delete import {0}", 0, array($bundle->getFieldValue('name'))));
}

function sort_by_type2($a, $b) {
 if ($a["obj_type"] == null && $b["obj_type"] == null) {
 return 0;
 } else if ($a["obj_type"] == null) {
 return 1;
 } else if ($b["obj_type"] == null) {
 return -1;
 }
 return $a["obj_type"] < $b["obj_type"];
} 

load_menu(1012, T_BUNDLE_IMPORT_ELEMENT, $BUNDLE_ID, "<span class=\"addInfo\">" . i18n("Delete import") . "</span>");

?>
