<?
node_include( "guifactory" );
node_include( "dbdate" );

mysession_var_reg("JAVAPARSER_STATISTICS_SHOW", TRUE);




function getNodesPublishingIntoCR() {
 $nodeIds = array();
 $rs = query("SELECT id FROM node WHERE disable_publish = 0 AND publish_contentmap = 1");
 foreach ( $rs["arr"] as $row ) {
 $nodeIds[] = $row["id"];
 }
 return $nodeIds;
}







function getObjectsCount() {
 $types = array(10002, 10007, 10008);
 $counts = array();
 $nodeIds = getNodesPublishingIntoCR();

 if (count($nodeIds) == 0) {
 foreach ( $types as $type ) {
 $counts[$type]["dirted"] = 0;
 $counts[$type]["delayed"] = 0;
 }
 } else {
 $nodeIds = implode(",", sqlf_value_array($nodeIds));

 foreach ( $types as $type ) {
 $rs = query("SELECT count(DISTINCT pq.obj_id, pq.channel_id) c FROM publishqueue pq WHERE pq.action != 'DELETE' AND pq.action != 'HIDE' AND pq.action != 'REMOVE' AND pq.obj_type = ".sqlf_value($type)." AND pq.delay = 0 AND pq.channel_id IN (".$nodeIds.")");
 $counts[$type]["dirted"] = $rs["arr"][0]["c"];
 
 $rs = query("SELECT count(DISTINCT pq.obj_id, pq.channel_id) c FROM publishqueue pq WHERE pq.action != 'DELETE' AND pq.action != 'HIDE' AND pq.action != 'REMOVE' AND pq.obj_type = ".sqlf_value($type)." AND pq.delay = 1 AND pq.channel_id IN (".$nodeIds.")");
 $counts[$type]["delayed"] = $rs["arr"][0]["c"];
 }
 }

 return $counts;
}

if($cmd == 'togglestatistics') {
 $JAVAPARSER_STATISTICS_SHOW = !$curval;
}

GUIFactory::setMainGUI( "main" );
$maingui = &GUIFactory::getGUI("main");
$maingui->includeJS("jquery-1.6.1.min");
$maingui->includeJS("jquery.autocomplete.min");
if ($FEATURE["quickjump"]) {
 $maingui->includeJS("GTXQuickJump");
}
reset($MODULES);


if ($FEATURE["tag_image_resizer"]) {
 
 if (!file($IMG_RESIZER_PATH."?cmd=status")) {
 halt(120, i18n("imgresizer unreachable", 0, $IMG_RESIZER_PATH));
 }
}
if ($FEATURE["javaparser"]) {
 node_class("codeparser");
 
 $javaParser =& CodeParser::getJavaParser();
 
 
 if(!$javaParser->checkLicenseKey()) {
 echo "<script language=\"javascript\">top.location.href = \"" . $PORTLETAPP_PREFIX . "activation\"</script>";
 exit(0);
 }
}
ini_restore("default_socket_timeout");

if ( $redir_content )
{
 $main = GUIFactory::getGUI("main");
 if ( $main->redirectToLastMain() )
 return;
}

function make_list($cols, $rows, $link, $title, $symbol, $addTable = "") {
 global $ITEMLIST_NOPAGING_PAGESIZE;
 $ret .= "<h2>$title</h2>"; 
 $lst = new item_list;
 $lst->cols = $cols;
 $lst->addtd["icon"] = "width=\"1%\"";

 if ($link) $lst->link["name"] = $link;
 $lst->rows = $rows;
 $lst->maxListItems = $ITEMLIST_NOPAGING_PAGESIZE;
 $ret .= $lst->outp();

 $ret .= $addTable;
 return $ret;
}


if ($LOAD_MODULE["content"]) {
 $sql = "SELECT page.id, folder.node_id AS node_id, page.name, page.status, page.edate, folder.id AS fid, folder.name AS fname, content.locked, folder.mother, folder.type_id, contentgroup.code 
FROM page, folder, content, contentgroup
WHERE page.editor = ".sqlf_tl_num($USER_ID)." AND page.folder_id = folder.id AND contentgroup.id = page.contentgroup_id
AND page.content_id = content.id ORDER BY page.edate DESC";
 $rs = query($sql,false,5);
 $o_pages = $rs["arr"];
}

if ($LOAD_MODULE["content"] && is_array($o_pages)) {
node_include( "folder_tree" );
while (list($key,$val) = each($o_pages)) {
 $pre = "";
 $rs["arr"][0]["mother"] = $val["mother"];
 $rs["arr"][0]["fname"] = $val["fname"];
 while ($rs["arr"][0]["mother"] != 0) {
 $sql = "SELECT folder.name AS fname, folder.id, folder.mother FROM folder WHERE id = ".sqlf_tl_num($rs["arr"][0]["mother"]);
 $rs = query($sql);
 $pre = $rs["arr"][0]["fname"]." / ".$pre;
 }
 $pre .= $val["fname"]." / ";
 $id = $val["fid"];
 $type = $val["type_id"];
 $ftree = get_folder_tree($val["fid"]);
 $atposidx = build_atposidx( $ftree );
 $tree_opener = "top.tree.location.href='$STAG&do=300&open_type=$T_FOLDER&open_id=".$val["fid"]."&atposidx=$atposidx'";
 $o_pages[$key]["name"] = "<div>".$pre."<a href=\"$STAG&do=14001&PAGE_ID=".$val["id"]."&FOLDER_ID=".$val["fid"]."&NODE_ID=".$val["node_id" ]."\" ".
 "onclick=\"$tree_opener\">".$val["name"]."</a></div>";
 $o_pages[$key]["edate"] = db2date($val["edate"]);
 $info = get_pageinfo($val['id']);
 $o_pages[$key]["icon"] = $PAGE_STATUS_ICON[$val["status"]];
 $o_pages[$key]["icon"] = get_pageicon($val['status'], $val['code']);
 if ($val["locked"] > 0 && ($TIME - $val["locked"]) < $LOCK_TIME) $o_pages[$key]["icon"] = $ICO_LOCK;
 $o_pages[$key]["icon"] = img($o_pages[$key]["icon"]);

}
reset($o_pages);
}

$page_box = make_list(array("icon","name"),$o_pages,"",i18n('379.pages'),$ICO_PAGE);

if ($LOAD_MODULE["content"]) {

$sql = "SELECT folder.id, folder.type_id, folder.mother, folder.name, max(page.edate) AS pedate FROM page, folder WHERE page.folder_id = folder.id AND page.editor = ".sqlf_tl_num($USER_ID)."
GROUP BY folder.id, folder.mother, folder.name ORDER BY pedate DESC";
$rs = query($sql,false,5);
$o_folder = $rs["arr"];
if (is_array($o_folder))
while (list($key,$val) = each($o_folder)) {
 $pre = "";
 $rs["arr"][0]["mother"] = $val["mother"];
 while ($rs["arr"][0]["mother"] != 0) {
 $sql = "SELECT folder.name, folder.id, folder.type_id, folder.mother FROM folder WHERE id = ".sqlf_tl_num($rs["arr"][0]["mother"]);
 $rs = query($sql);
 $type = $rs["arr"][0]["type_id"];
 $id = $rs["arr"][0]["id"];

 if (!$id) {
 continue;
 }

 $ftree = get_folder_tree($id);
 $atposidx = build_atposidx( $ftree );
 $tree_opener = "top.tree.location.href='$STAG&do=300&open_type=$T_FOLDER&open_id=$id&atposidx=$atposidx'";
 $pre = "<a href=\"$STAG&do=13011&FOLDER_ID=$id\" ".
 "onclick=\"$tree_opener\">".$rs["arr"][0]["name"]."</a> / ".$pre;
 }
 $type = $val["type_id"];
 $id = $val["id"];
 $ftree = get_folder_tree($id);
 $atposidx = build_atposidx( $ftree );
 $tree_opener = "top.tree.location.href='$STAG&do=300&open_type=$T_FOLDER&open_id=$id&atposidx=$atposidx'";
 $o_folder[$key]["name"] = "<div>".$pre."<a href=\"$STAG&do=13011&FOLDER_ID=$id\" ".
 "onclick=\"$tree_opener\">".$val["name"]."</a></div>";
 $o_folder[$key]["icon"] = img($ICO_FOLDER);
}
$folder_box = make_list(array("icon","name"),$o_folder,"",i18n('Folders'),$ICO_FOLDER);
}



node_include("T_TYPE");
$perm = perm ($USER_ID, $T_CONADMIN);
$perm_eta = $perm[8];

$perm2 = perm($USER_ID, $T_TASKADMIN);
$perm_tasks = $perm2[12];
$perm_sched = $perm2[0];
$task_jobs = tree_get_subfolders(T_JOB_GROUP, T_JOB_GROUP);

if ( $USER_ID == 1 || $FEATURE["admininfo"] || $perm_eta || $perm_tasks || $task_jobs ) {
 $o_infos = array();
 
 if ($LOAD_MODULE["content"] && ($USER_ID == 1 || $FEATURE["admininfo"] || $perm_eta) ) {
 global $ICO_INFO;

 
 $currentVersion = get_current_gcnversion();

 $objectcounts = getObjectsCount();

 $pagecount = $objectcounts[10007]["dirted"];
 $foldercount = $objectcounts[10002]["dirted"];
 $filecount = $objectcounts[10008]["dirted"];

 if ($USER_ID == 1 || $FEATURE["admininfo"]) {
 $o_pubqueue = get_pubqueue();
 $o_infos[] = array( "icon"=>img($ICO_PAGE_HI), "name"=>i18n("cn_pages_in_queue"), "value"=>count($o_pubqueue) );
 }
 
 
 



 $SEASON_SMILEYS = array(
 317 => array(
 'till' => 324,
 'src' => 'statussmiley_easter.gif',
 'height' => 36
 ),
 1027 => array(
 'till' => 1102,
 'src' => 'halloween_smiley.gif',
 'height' => 18
 ),
 1223 => array(
 'till' => 1226,
 'src' => 'statussmiley_weihnachten.gif',
 'height' => 18
 )
 );

 function sec2hms ($sec, $padHours = false) {
 
 $hms = "";
 
 
 
 
 $hours = intval(intval($sec) / 3600);
 
 
 $hms .= ($padHours)
 ? str_pad($hours, 2, "0", STR_PAD_LEFT). ':'
 : $hours. ':';
 
 
 
 
 
 $minutes = intval(($sec / 60) % 60);
 
 
 $hms .= str_pad($minutes, 2, "0", STR_PAD_LEFT). ':';
 
 
 
 $seconds = intval($sec % 60);
 
 
 $hms .= str_pad($seconds, 2, "0", STR_PAD_LEFT);
 
 return $hms;
 }
 
 function getIdleSmileySrc() {
 global $SEASON_SMILEYS;
 reset($SEASON_SMILEYS);
 $now = date("md");
 while (list($from,$seasonSmiley) = each($SEASON_SMILEYS)) {
 if ($from <= $now && $seasonSmiley['till'] >= $now) {
 return $seasonSmiley['src'];
 }
 }
 return 'statussmiley_idle1.gif';
 }

 function getSmileyHeight() {
 global $SEASON_SMILEYS;
 reset($SEASON_SMILEYS);
 $now = date("md");
 while (list($from,$seasonSmiley) = each($SEASON_SMILEYS)) {
 if ($from <= $now && $seasonSmiley['till'] >= $now) {
 return $seasonalSmiley['height'];
 }
 }
 return 18; 
 }
 
 $statussmiley1 = "$STAG_PREFIX?do=11&module=$MODULE&img=statussmiley_1.gif";
 $statussmiley2 = "$STAG_PREFIX?do=11&module=$MODULE&img=statussmiley_2.gif";
 $statussmiley3 = "$STAG_PREFIX?do=11&module=$MODULE&img=statussmiley_3.gif";
 $statussmiley_think = "$STAG_PREFIX?do=11&module=$MODULE&img=statussmiley_think.gif";
 
 $statussmiley_idle = "$STAG_PREFIX?do=11&module=$MODULE&img=" . getIdleSmileySrc();
 $statussmiley_none = "$STAG_PREFIX?do=11&module=system&img=null.gif";

 $autoupdate = new AutoUpdate();
 $updateVersion = $autoupdate->getLatestVersion();
 $addUpdateInfo = '';
 if ( perm($USER_ID, T_SELFUPDATE, "", 0) && compare_gcnversion($updateVersion, $currentVersion) === 1) {
 $alt = i18n('Update available') . ' (' . prettyprint_gcnversion($updateVersion) . ')';
 $addUpdateInfo = ' <a href="' . $STAG . '&do=1040">' . $alt . '</a>'; 
 }

 global $MAJORMINORVERSION;
 $o_infos[] = array("icon"=>img($ICO_ADMIN), "name"=>i18n("Version") .
 " Gentics Content.Node", "value"=> prettyprint_gcnversion($currentVersion) . $addUpdateInfo);
 
 $o_infos[] = array("icon"=>img($ICO_ADMIN), "name"=>i18n("startpage.guides.linktext"), "value"=> '<a target="_blank" href="/CNPortletapp/guides/">Version ' . prettyprint_gcnversion($currentVersion) . '</a>&nbsp;|&nbsp;<a target="_blank" href="http://www.gentics.com/Content.Node/guides/">'.i18n("latest version").'</a>');

 $_lic = get_license_key(4);
 if (strlen($_lic) == 4) {
 $installname = '';
 if( $INSTALLATION_NAME !== null ) {
 $installname = ' '.i18n('Installation Name').': ' . $INSTALLATION_NAME;
 }
 $o_infos[] = array("icon"=>img($ICO_ADMIN), "name"=>i18n("License key trimmed"), "value"=>$_lic." ...".$installname);
 }
 
 if( $FEATURE['javaparser'] ) {
 node_class("codeparser");
 
 $javaParser =& CodeParser::getJavaParser();
 
 
 $javaParser->getPublishInfo(true);
 $running = ($JAVAPARSER_RETURN["params"]["Running"][0] == "true");
 $eta = $JAVAPARSER_RETURN["params"]["ETA"][0];
 if ($eta > 24*60*60) {
 if ((int) ($eta / (24*60*60)) > 1) {
 $eta = (int) ($eta / (24*60*60)) . ' '.i18n('sn_days');
 }
 else {
 $eta = (int) ($eta / (24*60*60)) . ' '.i18n('day');
 }
 } else {
 $eta = sec2hms($eta, true);
 }
 $allPhases = split(";",$JAVAPARSER_RETURN["params"]["AllPhases"][0]);
 $phase = $JAVAPARSER_RETURN["params"]["Phase"][0];
 $phaseCount = $JAVAPARSER_RETURN["params"]["PhaseCount"][0];
 $phaseNumber = $JAVAPARSER_RETURN["params"]["PhaseNumber"][0];
 $JS .= 'phase_i18n = new Array();';
 $JS .= 'phase_i18n_publishing = "' . i18n('Publishing') . '";';
 $JS .= 'phase_i18n_waiting = "' . i18n('Waiting') . '";';
 foreach($allPhases as $phaseName) {
 $JS .= 'phase_i18n["'.$phaseName.'"] = "'.i18n($phaseName).'";';
 }
 $JS .= 'phase_i18n_remaining = "' . i18n('remaining') . '";';
 if(!$eta && $eta !== 0) {
 $eta = "--:--";
 $minute_eta = "-";
 } else {
 $minute_eta = $eta ? (int) (($eta / 60.0) + 1) : 0;
 }

 $status = '';
 if(!$running) {
 $status = i18n("Waiting");
 } else {
 $status = i18n("Publishing")." ".$JAVAPARSER_RETURN["params"]["Progress"][0]."% (".i18n($phase).")";
 }
 if($running) {
 $pagecount_tmp = $JAVAPARSER_RETURN["params"]["Pages"][0];
 if($pagecount_tmp >= 0) {
 $pagecount = $pagecount_tmp;
 }
 $filecount_tmp = $JAVAPARSER_RETURN["params"]["Files"][0];
 if($filecount_tmp >= 0) {
 $filecount = $filecount_tmp;
 }
 $foldercount_tmp = $JAVAPARSER_RETURN["params"]["Folders"][0];
 if($foldercount_tmp >= 0) {
 $foldercount = $foldercount_tmp;
 }
 }
 
 
 
 $o_infos[] = array( "icon" => img($ICO_PAGE_HI), "name" => i18n("Publish status"), "value" => "<span id='status'>$status</span>" );
 

 if ($objectcounts[10007]["delayed"] > 0) {
 $delayedpage_info = " (".i18n("pages to publish delayed").": ".$objectcounts[10007]["delayed"].")";
 }
 if ($objectcounts[10002]["delayed"] > 0) {
 $delayedfolder_info = " (".i18n("maintenance_delayed_folders").": ".$objectcounts[10002]["delayed"].")";
 }
 if ($objectcounts[10008]["delayed"] > 0) {
 $delayedfile_info = " (".i18n("maintenance_delayed_files").": ".$objectcounts[10008]["delayed"].")";
 }
 $o_infos[] = array( "icon"=>img($ICO_PAGE_HI), "name"=>i18n("maintenance_dirted_files"), "value"=>"<span id='pagecount'>$filecount$delayedfile_info</span>" );
 $o_infos[] = array( "icon"=>img($ICO_PAGE_HI), "name"=>i18n("maintenance_dirted_folders"), "value"=>"<span id='pagecount'>$foldercount$delayedfolder_info</span>" );
 $o_infos[] = array( "icon"=>img($ICO_PAGE_HI), "name"=>i18n("Pages to publish"), "value"=>"<span id='pagecount'>$pagecount$delayedpage_info</span>" );

 
 $show_graph_link = $FEATURE["javaparser_eta_statistics"] && !$FEATURE["javaparser_eta_statistics_nograph"];
 $o_infos[] = array( "icon"=>img($ICO_PAGE_HI), "name"=>i18n("Publish ETA"), "value"=> "".($show_graph_link ? "<a href='$STAG&do=3&cmd=togglestatistics&curval=$JAVAPARSER_STATISTICS_SHOW'>" : '' )."<span id='sec_eta' style='display:inline;padding-left:10px;vertical-align:middle'>$eta</span>".($show_graph_link?"</a>":''));
 

 
 if($USER_ID == 1) {
 $o_infos[] = array( "icon"=>img($ICO_ADMIN), "name"=>i18n("Debug"), "value" => "<span id='gtx_debug'></span>" );
 }
 


 $imageurl = 'content/log/publishrun_current.etastat.png';
 if(file_exists("$FILEPATH/$imageurl") && $FEATURE['javaparser_eta_statistics'] && $JAVAPARSER_STATISTICS_SHOW) {
 $etastatimgurl = "$STAG&do=11&furl=$imageurl";
 }

 } else {

 $sql = "SELECT intvalue FROM nodesetup WHERE name='publish_eta'";
 $rs = query( $sql );
 $publish_eta = $rs["arr"][0]["intvalue"]?(int) (($rs["arr"][0]["intvalue"] / 60.0) + 1):0;
 if (!$publish_eta) $publish_eta = "-";
 $o_infos[] = array( "icon"=>img($ICO_PAGE_HI), "name"=>i18n("Publish ETA"), "value"=>$publish_eta );
 }

 }
 
 if ( $perm_tasks || $task_jobs ) {
 $sql = "SELECT jr.id, jr.starttime, jr.endtime, jr.returnvalue, jr.output, j.name, j.id job_id FROM
		        (SELECT job.id, job.name, MAX(jobrun.starttime) last FROM job JOIN jobrun ON (job.id = jobrun.job_id) 
			   WHERE jobrun.valid = 1 AND job.status = 1 GROUP BY job.id) j
			JOIN jobrun jr ON (j.id = jr.job_id AND jr.starttime = j.last) WHERE jr.returnvalue != 0";
 if (!$FEATURE['nojobrunoptimization']) {
 $sql = "select jr.id, jr.starttime, jr.endtime, jr.returnvalue, jr.output, j.name, j.id job_id from job j inner join jobrun jr on j.last_valid_jobrun_id = jr.id where j.status = 1 and jr.returnvalue != 0";
 }
 $rs = query($sql);

 $ret = array();
 if ( !$perm_tasks ) {
 foreach ($rs["arr"] as $row) {
 if ( !perm($USER_ID, T_JOB, $row["job_id"], 0) ) continue;
 $ret[] = $row;
 }

 } else {
 $ret = $rs["arr"];
 }
 
 if ( count($ret) == 0 ) {
 $msg = "<font color='green'>".i18n("OK")."</font>";
 if ( $perm_sched ) {
 $msg = "<a href=\"$STAG&do=870\">$msg</a>";
 }
 } else {
 if ( $perm_sched ) {
 $msg = "<a href=\"$STAG&do=870\"><font color='red'>".i18n("Failed")."</font></a> (";
 } else {
 $msg = "<font color='red'>".i18n("Failed")."</font> (";
 }
 $i = 0;
 foreach ($ret as $row) {
 
 if ( $i > 2 ) {
 $msg .= ", ... ";
 break;
 }

 if ( $i > 0 ) { 
 $msg .= ", ";
 }
 if ( $row["output"] && $perm_sched ) {
 $msg .= "<a href=\"$STAG&do=874&id=".$row["id"]."&back=870\">".$row["name"]."</a>";
 } else {
 $msg .= $row["name"];
 }
 
 $i++;
 }
 $msg .= ")";
 }
 $o_infos[] = array( "icon"=>img($ICO_TREEMENU), "name"=>i18n("Last status of tasks"), "value"=>$msg );
 }

 foreach($o_infos as $key => $value) {
 if ($o_infos[$key]['name'] == "Version Gentics Content.Node") {
 $tableHeader .= '
			<tr>
				<!--th class="first"><div>'.$o_infos[$key]['name'].'</div></th-->
				<td class="first"><div>'.$o_infos[$key]['name'].' '.$o_infos[$key]['value'].'</div></td>
			</tr>';

 } else {
 $tableBody .= '
				<tr>
					<!--th><div>'.$o_infos[$key]['name'].'</div></th-->
					<td class="bg"><div>'.$o_infos[$key]['name'].': '.$o_infos[$key]['value'].'</div></td>
				</tr>';
 }
 }

 $info_box .= '
		<h2>Admin Info</h2>
			<table class="adminInfo" width="100%" border=0 cellpadding=0 cellspacing=0>' . $tableHeader . $tableBody .'</table>';
}


$bonus = get_bonus();












$ires = item_order("timestamp","DESC",array("msg.msg"=>"msg"));

 
 $sql = "SELECT msg.from_user_id, msg.id, msg.oldmsg as old, msg.timestamp, systemuser.firstname AS firstname, systemuser.lastname AS lastname, msg.msg ".$ires["select"]." 
FROM msg LEFT JOIN systemuser ON systemuser.id = msg.from_user_id
WHERE to_user_id = ".sqlf_tl_num($USER_ID)." AND oldmsg = 0".$ires["orderby"]." LIMIT 10";

 $rs = query($sql);
 if ($rs["arr"]) {
 $count = 0;
 while (list($key,$val) = each($rs["arr"])) {
 $val["icon"] = img($ICO_MSG);
 $val["timestamp"] = "<div>".db2date($val["timestamp"],"j.n.Y H:i")."</div>";
 $val["lastname"] = $val["lastname"] ." ".$val["firstname"];
 if ($val["from_user_id"] == 1 || $val['from_user_id'] == -1) {
 $val["lastname"] = "System";
 }
 $val["name"] = "<b>".($val['lastname'] == '' || $val['lastname'] == ' ' ? '-' : $val['lastname']) ."</b>";
 $val["msg"] = str_replace("\r","",str_replace("\n","\\n",addslashes(str_replace("\"","''",$val["msg"]))));
 $o_inbox[$key] = $val;
 $count++;

 if ($count >= 5) {
 break;
 }
 }
 }
 if ($rs["num"] > 5 && !$FEATURE["no_inbox"]) $inbox_add = "<a href=\"$STAG&do=8\" onclick=\"progress(top.menu); return true; \">".i18n("More messages ..")."</a><br/><br/>";
 $inbox_box = make_list(array("icon","name","timestamp"),$o_inbox,"$STAG&do=6&msg_id=\$id",i18n('915.inbox'),$ICO_INBOX, $inbox_add);


if (($bonus > $BONUS_MSG) && !$FEATURE["no_userlist_on_startpage"]) {
 $title = i18n('sn_send_user_message');

 $online_user = get_online_user();
 
 $max_users = 5;
 
 if (count($online_user) > 0) {
 $count = 0;
 while (list($k,$v) = each($online_user)) {
 
 $o_sendmsg[$k]["icon"] = img($ICO_USER);;
 $o_sendmsg[$k]["user_id"] = $v["user_id"];
 $o_sendmsg[$k]["name"] = $v["lastname"]." ".$v["firstname"];
 $count++;
 if ($max_users > 0 && $count >= $max_users) {
 break;
 }
 
 }
 }

 if ($max_users > 0 && count($online_user) > $max_users) {
 $add_table = "<a href=\"$STAG&do=111\" onClick=\"window.open('$STAG&do=411','users','dependent=yes,status=no,width=550,height=400,resizable=yes,scrollbars=yes'); return false;\">".i18n("more_users")."</a>";
 } else {
 $add_table = "";
 }

 if ( !$FEATURE["no_inbox"] ) $sendmsg_box = make_list(array("icon","name"),$o_sendmsg,"$STAG&do=6&to=\$user_id",i18n('Users online'),$ICO_MSG, $add_table);
 else $sendmsg_box = make_list(array("icon","name"),$o_sendmsg,"#",i18n('Users online'),$ICO_MSG, $add_table);
}

if ($USER_ID==1) {
 $dev_box = "
<p><b>Developer Staff</b><br>
<li><a href=$STAG&do=800>go to -> DIC</a></li>
<li><a href=doc/>go to -> DOC</a></li>
</p>";
 
 while (list($name, $status) = each($MODULES)) {
 $dev_box .= "<b>$name:</b>&nbsp;......$status<br>";
}

} 

load_menu(301);

$HTML_BODY_TAG ="onUnLoad=\"showAssFrame();\"";
?>
