<?php










function getPermissionInfoLinkText($groupId, $objectType, $objectId) {
 if ($objectType === T_FOLDER && isset($GLOBALS['groupsWithPermissionBits'][$groupId])) {
 
 
 return " - - - <span style=\"font-style: italic;\">"
 . pretty_perm_humanReadable($objectType, $GLOBALS['groupsWithPermissionBits'][$groupId]);
 "</span>";
 }

 return "";
}

GUIFactory::setMainGUI("main");

$gdo = new GenericDo(i18n("Permissions"));

switch ($PERM_ACTION) {
 case "cancel":
 case "ok":
 $gdo->end();
 return;
}


$tree = new tree();
$tree->type[T_GROUPADMIN]["allowlink"] = false;
$tree->type[T_GROUP]["link"] = "do=506&redo=$DO" . $gdo->getLinkAppendix();

if (!empty($FOLDER_ID)) {
 
 $requestParameters = array();

 $restPath = "rest/perm/list/" . T_FOLDER . "/" . $FOLDER_ID;
 $url = $GLOBALS['CN_LOCAL_SERVER'] . $GLOBALS['PORTLETAPP_PREFIX_INTERNAL']. $restPath;
 $requestParameters['sid'] = $GLOBALS['SESSION_TOKEN'];

 
 $url .= "?" . http_build_query($requestParameters);

 $fetchCurl = new fetchCurl();
 $fetchCurl->setUrl($url);
 $responseBody = $fetchCurl->doRequest();
 
 
 $returnCode = $fetchCurl->getReturnCode();
 if (empty($returnCode)) {
 halt(7,'Unable to connect to CNPortletapp for getting list data via {' . $url . '}');
 } else if ($returnCode >= 400) {
 halt(120, 'Accessing CNPortletapp returned error ' . $fetchCurl->getReturnCode() . " for url " . $url);
 }

 
 
 
 $response = json_decode($responseBody, true);
 $groupsWithPermissionBits = $response['groups'];

 
 
 $tree->type[T_GROUP]["prepend"] = addslashes("<span onmouseover=\"ph(event,")
 . "'\".cleannl2br(pretty_perm_help(\$nid, " . T_FOLDER . ", $FOLDER_ID)).\"'" . addslashes(");\" onmouseout=\"phr();\">");
 
 $tree->type[T_GROUP]["append"] = "getPermissionInfoLinkText(\$nid, " . T_FOLDER . ", $FOLDER_ID) . '</span>'";
}

$treeOutput = $tree->walktree(0, false, 0, T_GROUPADMIN);
