<?
$mainGUI = &GUIFactory::setMainGUI( "main" );

$mainGUI->includeJS("jquery-1.6.1.min");

if (!is_array($obj_id)) {
 $obj_id = array($obj_id);
}
$show_info_max = 5;

class DummyComparator {
 function compareTo( $value ) {
 return 0;
 }
}

class IconFormatter extends ResultsetFormatter {
 var $d_icon;

 function IconFormatter( $icon ) {
 $this->d_icon = $icon;
 }

 function format( $row ) {
 return img($this->d_icon);
 }
}


mysession_var_reg( "CHANNELSYNC_SELTYPE" );
if ($_POST["channelsync_seltype"]) {
 $CHANNELSYNC_SELTYPE = $_POST["channelsync_seltype"];
 unset($CHANNELSYNC_SELTYPE[0]);
}




class CheckBoxFormatter extends ResultsetFormatter {
 var $d_fieldname;
 var $d_idfield;

 function CheckBoxFormatter ($fieldname, $idfield = "id") {
 $this->d_fieldname = $fieldname;
 $this->d_idfield = $idfield;
 }

 function format ($row) {
 global $CHANNELSYNC_SELTYPE;
 $checked = $CHANNELSYNC_SELTYPE[$row[$this->d_idfield]] ? "checked" : "";
 return "<input type='checkbox' class='".$this->d_fieldname."' name='".$this->d_fieldname."[".$row[$this->d_idfield]."]' value='1' $checked>";
 }
}


if ($channel_id) {
 $NODE_ID = $channel_id;
}
$masterNodes = getMasterNodes($NODE_ID);
$masterNodes = array_reverse($masterNodes);
$visibleNodeIds = getVisibleNodeIds();
$options = array();
while (list($key, $val) = each($masterNodes)) {
 $masterinfo = get_nodeinfo($val);
 
 if (in_array($masterinfo["id"], $visibleNodeIds)) {
 $options[$val] = img($masterinfo["master_id"] != 0 ? $ICO_DOMAIN_CHANNEL : $ICO_DOMAIN)."&nbsp;".htmlentities_utf8($masterinfo["name"]);
 }
}

$form = new HtmlForm3("channelsync");
if ($form->isNew()) {
 
 $CHANNELSYNC_SELTYPE = array("page" => "1", "template" => "1", "folder" => "1", "image" => "1", "file" => "1");

 switch($obj_type) {
 case T_PAGE:
 $icon = $ICO_PAGE;
 $label = count($obj_id) > 1 ? "pages" : "page";

 $info = "";
 for ($i = 0; $i < min(count($obj_id), $show_info_max); ++$i) {
 $oinfo = get_pageinfo($obj_id[$i]);
 if ($i > 0) {
 $info .= "<br/>";
 }
 $info .= img($icon)."&nbsp;".htmlentities_utf8($oinfo["name"]);
 }

 if (count($obj_id) > $show_info_max) {
 $info .= "<br/>".i18n("channelsync.further", 0, count($obj_id) - $show_info_max);
 }

 break;
 case T_TEMPLATE:
 $icon = $ICO_TPL;
 $label = count($obj_id) > 1 ? "templates" : "template";

 $info = "";
 for ($i = 0; $i < min(count($obj_id), $show_info_max); ++$i) {
 $oinfo = get_templateinfo($obj_id[$i]);
 if ($i > 0) {
 $info .= "<br/>";
 }
 $info .= img($icon)."&nbsp;".htmlentities_utf8($oinfo["name"]);
 }

 if (count($obj_id) > $show_info_max) {
 $info .= "<br/>".i18n("channelsync.further", 0, count($obj_id) - $show_info_max);
 }

 break;
 case T_FOLDER:
 $icon = $ICO_FOLDER;
 $label = "folder";
 $oinfo = get_folderinfo($obj_id[0]);
 $info = img($icon)."&nbsp;".htmlentities_utf8($oinfo["name"]);
 $FOLDER_ID = $obj_id[0];
 break;
 case T_IMAGE:
 $icon = $ICO_IMAGE;
 $label = count($obj_id) > 1 ? "images" : "image";

 $info = "";
 for ($i = 0; $i < min(count($obj_id), $show_info_max); ++$i) {
 $oinfo = get_fileinfo($obj_id[$i]);
 if ($i > 0) {
 $info .= "<br/>";
 }
 $info .= img($icon)."&nbsp;".htmlentities_utf8($oinfo["name"]);
 }

 if (count($obj_id) > $show_info_max) {
 $info .= "<br/>".i18n("channelsync.further", 0, count($obj_id) - $show_info_max);
 }

 break;
 case CT_FILE:
 $icon = $ICO_FILE;
 $label = count($obj_id) > 1 ? "files" : "file";

 $info = "";
 for ($i = 0; $i < min(count($obj_id), $show_info_max); ++$i) {
 $oinfo = get_fileinfo($obj_id[$i]);
 if ($i > 0) {
 $info .= "<br/>";
 }
 $info .= img($icon)."&nbsp;".htmlentities_utf8($oinfo["name"]);
 }

 if (count($obj_id) > $show_info_max) {
 $info .= "<br/>".i18n("channelsync.further", 0, count($obj_id) - $show_info_max);
 }

 break;
 }
 $channelinfo = get_nodeinfo($channel_id);

 $form->setHeader(i18n("channelsync"));

 $main = new TabComponent();

 
 $overview = new ListComponent();
 $main->setTab('overview', i18n("Overview"), $overview);

 
 $overview->setComponent('object', $label = new LabelComponent(i18n($label), $info, true));
 $label->setHelp(i18n('channelsync.selected.help'));

 
 if ($obj_type == T_FOLDER) {
 $list = new ArrayDatasource(array(), array("check" => "<input type='hidden' name='channelsync_seltype[]'>".img($ICO_CHECK_ALL, 0, "", "", "", "", "", "", NULL, NULL, "jQuery('input.channelsync_seltype').attr('checked', jQuery(this).data('channelsync_seltype')).each(function(i, item) {jQuery(item).triggerHandler('change'); }); jQuery(this).data('channelsync_seltype', !jQuery(this).data('channelsync_seltype'))"), "icon" => "", "type" => "", "localized" => i18n("localized"), "local" => i18n("local")));
 $list->addFormatter( "check", new CheckBoxFormatter("channelsync_seltype") );
 $itemlist = new ItemListComponent( i18n("channelsync.affected_objects"), new ItemList3("affected", $list ) );
 $itemlist->setOptional(true);
 $overview->setComponent('affected', $itemlist);
 }

 
 $overview->setComponent('channel', $label = new LabelComponent(i18n('channel'), img($ICO_DOMAIN_CHANNEL)."&nbsp;".htmlentities_utf8($channelinfo["name"]), true));
 $label->setHelp(i18n('channelsync.channel.help'));
 $overview->setComponent('master', $radio = new RadioListComponent(i18n('channelsync.push.master'), $options, $masterNodes[count($masterNodes) - 1], false));
 $radio->setHelp(i18n('channelsync.push.master.help'));
 if (count($options) == 0) {
 $radio->setHidden(true);
 }

 
 $check = new CheckboxComponent(i18n('recursive'));
 $check->setHelp(i18n('channelsync.recursive.help'));
 $check->setOnChangeAction(new FormAction());
 $overview->setComponent('recursive', $check);
 if ($obj_type != T_FOLDER) {
 $check->setHidden(true);
 }

 
 $overview->setComponent('obj_type', new HiddenComponent($obj_type));
 $overview->setComponent('channel_id', new HiddenComponent($channel_id));
 $overview->setComponent('backdo', new HiddenComponent($backdo));
 $overview->setComponent('obj_id', new HiddenComponent(implode(",",$obj_id)));

 
 if ($obj_type == T_FOLDER) {
 $details = new TabComponent();
 $main->setTab('details', i18n("Details"), $details);

 
 $plist = new ArrayDatasource(array(), array(
 "icon" => "",
 "name" => i18n("Name"),
 "language" => "",
 "lang_imgs" => i18n('language'),
 "pedate" => i18n('last edited'),
 "filename" => i18n('filename'),
 "tname" => i18n('template'),
 "folder" => i18n('folder')));
 $details->setTab('pages', i18n("Pages"), new ItemListComponent( null, $il3 = new ItemList3("pages", $plist ) ));
 $il3->setResizable(false);

 
 $ilist = new ArrayDatasource(array(), array(
 "icon" => "",
 "name" => i18n("Name"),
 "edate" => i18n('last edited'),
 "filetype" => i18n("file_type"),
 "filesize" => i18n('filesize'),
 "path" => i18n('Folder')));
 $ilist->addFormatter( "icon", new IconFormatter($ICO_IMG) );
 $details->setTab('images', i18n("Images"), new ItemListComponent( null, $il3 = new ItemList3("images", $ilist ) ));
 $il3->setResizable(false);
 
 
 $flist = new ArrayDatasource(array(), array(
 "icon" => "",
 "name" => i18n("Name"),
 "edate" => i18n('last edited'),
 "filetype" => i18n("file_type"),
 "filesize" => i18n('filesize'),
 "path" => i18n('Folder')));
 $flist->addFormatter( "icon", new IconFormatter($ICO_FILE) );
 $details->setTab('files', i18n("Files"), new ItemListComponent( null, $il3 = new ItemList3("files", $flist ) ));
 $il3->setResizable(false);
 
 
 $tlist = new ArrayDatasource(array(), array("icon" => "", "name" => i18n("Name")));
 $tlist->addFormatter( "icon", new IconFormatter($ICO_TPL) );
 $details->setTab('templates', i18n("Templates"), new ItemListComponent( null, $il3 = new ItemList3("templates", $tlist ) ));
 $il3->setResizable(false);
 
 
 $folist = new ArrayDatasource(array(), array("icon" => "", "name" => i18n("Name"), "path" => i18n('Folder')));
 $folist->addFormatter( "icon", new IconFormatter($ICO_FOLDER) );
 $details->setTab('folders', i18n("Folders"), new ItemListComponent( null, $il3 = new ItemList3("folders", $folist ) ));
 $il3->setResizable(false);
 }

 $form->addComponent('main', $main);
 $form->addButton('push', $pushButton = new Button(i18n("channelsync.push")), new SimpleFormAction("push2master"), false);
 $pushButton->setHelp(i18n('channelsync.push.help'));
 $form->addButton('unlocalize', $unlocalizeButton = new Button(i18n("channelsync.unlocalize")), new SimpleFormAction("unlocalize"), false);
 $unlocalizeButton->setHelp(i18n('channelsync.unlocalize.help'));
 $form->addButton('cancel', new Button(i18n("cancel")), new RedoFormAction($backdo), false);
}

$mainComp = &$form->resolveComponent('main');
$detailsComp = &$form->resolveComponent('main.details');
$masterComp = &$form->resolveComponent('main.overview.master');
$recursiveComp = &$form->resolveComponent('main.overview.recursive');
$objTypeComp = &$form->resolveComponent('main.overview.obj_type');
$objType = $objTypeComp->getValue();
$objIdComp = &$form->resolveComponent('main.overview.obj_id');
$channelIdComp = &$form->resolveComponent('main.overview.channel_id');
if ($objType == T_FOLDER) {
 $affectedComp = &$form->resolveComponent('main.overview.affected');
 $affectedDS = &$affectedComp->getDatasource();
}
$pushButton = &$form->getButton('push');
$unlocalizeButton = &$form->getButton('unlocalize');

switch($objType) {
 case T_PAGE:
 $restPart = "page";
 break;
 case T_TEMPLATE:
 $restPart = "template";
 break;
 case T_FOLDER:
 $restPart = "folder";
 break;
 case T_IMAGE:
 case CT_FILE:
 $restPart = "file";
 break;
 default:
 halt(7,'Could not get objType');
}
$objId = explode(",", $objIdComp->getValue());
$recursive = ($recursiveComp && $recursiveComp->isChecked()) ? "true" : "false";
$channelId = $channelIdComp->getValue();
$masterNodes = getMasterNodes($channelId);


$fc = new fetchCurl();
if (count($objId) == 1) {
 $url = $CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/$restPart/localizationinfo/".$objId[0]."?sid=$SESSION_TOKEN&nodeId=$channelId&recursive=$recursive";
} else {
 $url = $CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/$restPart/localizationinfo?sid=$SESSION_TOKEN&nodeId=$channelId&recursive=$recursive";
 reset($objId);
 while (list($key, $val) = each($objId)) {
 $url .= "&id=".$val;
 }
}
$fc->setUrl($url);
$json = $fc->doRequest();


if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp.');
} else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
}

$locInfo = json_decode($json, true);
$channelMap = array();
while (list($key, $val) = each($locInfo["channels"])) {
 $channelMap[$val["channelId"]] = $val;
}


$disabled = array();
$disablePush = false;
while (list($key, $masterId) = each($masterNodes)) {
 if ($disablePush) {
 $disabled[] = $masterId;
 } else if ($channelMap[$masterId]["local"] > 0 || $channelMap[$masterId]["localized"] > 0) {
 $disablePush = true;
 }
}

$masterComp->setDisabledOptions($disabled);

if ($objType == T_FOLDER) {
 
 $infoAbout = array(
 array("page", img($ICO_PAGE), i18n("Pages")),
 array("image", img($ICO_IMAGE), i18n("Images")),
 array("file", img($ICO_FILE), i18n("Files")),
 array("template", img($ICO_TPL), i18n("Templates")),
 array("folder", img($ICO_FOLDER), i18n("Folder"))
 );
 while (list($key, $val) = each($infoAbout)) {
 $info = $channelMap[$channelId][$val[0]];
 $affectedDS->setItem($val[0], array("id" => $val[0], "icon" => $val[1], "type" => $val[2], "localized" => ($info ? $info["localized"] : "0"), "local" => ($info ? $info["local"] : "0")));
 }
}


if ($channelMap[$channelId]["local"] + $channelMap[$channelId]["localized"] > 0) {
 if (count($options) > 0) {
 $pushButton->setEnabled(true);
 } else {
 $pushButton->setEnabled(false);
 }
 $unlocalizeButton->setEnabled(true);
} else {
 $pushButton->setEnabled(false);
 $unlocalizeButton->setEnabled(false);
}


if ($mainComp->getActiveTabName() == 'details') {
 switch ($detailsComp->getActiveTabName()) {
 case 'pages':
 $ires = array('field' => 'name', 'way' => 'ASC');
 node_include("keymapper");
 $km = new KeyMapper(array(
 "fileName" => "filename",
 "cdate" => "pcdate",
 "edate" => "pedate",
 "language" => "code",
 "template.name" => "tname",
 "template.id" => "template_id",
 "creator.firstName" => "pc_firstname",
 "creator.lastName" => "pc_lastname",
 "editor.firstName" => "pe_firstname",
 "editor.lastName" => "pe_lastname",
 "channelId" => "channel_id",
 "languageVariants" => "lang",
 "folderId" => "folder_id",
 "obj_type" => "10007",
 "path" => "folder"
 ));
 $search = array();
 $search["inherited"] = "false";
 if ($recursiveComp->isChecked()) {
 $search["recursive"] = "true";
 }
 $pages = getPagesFromREST($objId[0], null, null, $search, $ires, $km, 0, -1);
 foreach ($pages as &$page) {
 $page["pedate"] = db2date($page["pedate"]);
 $page["pcdate"] = db2date($page["pcdate"]);
 switch ($page["status"]) {
 case 2:
 $page["icon"] = img($ICO_PAGE,0,i18n('published'));
 break;
 case 3:
 $page["icon"] = img($ICO_PAGE_OFF,0,i18n('cn_offline'));
 break;
 case 4:
 $page["icon"] = img($ICO_PAGE_QUEUE,0,i18n('queued'));
 break;
 case 5:
 $page["icon"] = img($ICO_PAGE_TIME,0, i18n("not_in_time_frame"));
 break;
 case 6:
 $page["icon"] = img($ICO_PAGE_PUBAT,0, i18n("not_in_time_frame"));
 break;
 default:
 
 $page["icon"] = img($ICO_PAGE_HI,0, i18n("being_edited"));
 break;
 }
 }
 $detailsComp = &$form->resolveComponent('main.details.pages');
 $detailsDS = &$detailsComp->getDatasource();
 $detailsDS->setItems($pages);
 break;
 case 'images':
 case 'files':
 $ires = array('field' => 'name', 'way' => 'ASC');
 
 $url = $CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/folder/";
 if ($detailsComp->getActiveTabName() == "images") {
 $url .= "getImages/".$objId[0]."?sid=$SESSION_TOKEN&nodeId=$NODE_ID&sortby={$ires['field']}&sortorder={$ires['way']}";
 } else {
 $url .= "getFiles/".$objId[0]."?sid=$SESSION_TOKEN&nodeId=$NODE_ID&sortby={$ires['field']}&sortorder={$ires['way']}";
 }
 $url .= "&inherited=false";
 if ($recursiveComp->isChecked()) {
 $url .= "&recursive=true";
 }

 $fc->setUrl($url);
 $json = $fc->doRequest();

 
 if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp.');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
 }

 $files = json_decode($json,true);
 $files = $files["files"];

 
 node_include("keymapper");
 $km = new KeyMapper(array(
 "folderId" => "folder_id",
 "fileSize" => "filesize",
 "fileType" => "filetype",
 "editor.firstName" => "e_firstname",
 "editor.lastName" => "e_lastname",
 "creator.firstName" => "c_firstname",
 "creator.lastName" => "c_lastname",
 "channelId" => "channel_id"
 ));
 $files = $km->remap($files);
 foreach ($files as &$file) {
 $file["edate"] = db2date($file["edate"]);
 $file["cdate"] = db2date($file["cdate"]);
 $file["filetype"] = file_type($file["filetype"]);

 
 $file["filesize"] = ceil($file["filesize"]/1024)."&nbsp;". i18n("kb");
 }

 $detailsComp = &$form->resolveComponent('main.details.'.$detailsComp->getActiveTabName());
 $detailsDS = &$detailsComp->getDatasource();
 $detailsDS->setItems($files);

 break;
 case 'templates':
 
 $ires = array();
 $url = $CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/folder/getTemplates/$FOLDER_ID?sid=$SESSION_TOKEN&nodeId=$NODE_ID&sortby={$ires['field']}&sortorder={$ires['way']}&inherited=false";
 if ($recursiveComp->isChecked()) {
 $url .= "&recursive=true&reduce=true";
 }

 $fc->setUrl($url);
 $json = $fc->doRequest();

 
 if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp.');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
 }

 $templates = json_decode($json,true);
 $templates = $templates["templates"];

 
 node_include("keymapper");
 $km = new KeyMapper(array(
 "folderId" => "folderid",
 "editor.firstName" => "e_firstname",
 "editor.lastName" => "e_lastname",
 "creator.firstName" => "c_firstname",
 "creator.lastName" => "c_lastname",
 "markupLanguage.name" => "type",
 "channelId" => "channel_id"
 ));
 $templates = $km->remap($templates);

 $detailsComp = &$form->resolveComponent('main.details.templates');
 $detailsDS = &$detailsComp->getDatasource();
 $detailsDS->setItems($templates);

 break;
 case 'folders':
 
 $ires = array();
 $url = $CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/folder/getFolders/".$objId[0]."?sid=$SESSION_TOKEN&nodeId=$NODE_ID&sortby={$ires['field']}&sortorder={$ires['way']}&inherited=false";
 if ($recursiveComp->isChecked()) {
 $url .= "&recursive=true";
 }

 $fc->setUrl($url);
 $json = $fc->doRequest();

 
 if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp.');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
 }

 $folders = json_decode($json,true);
 $folders = $folders["folders"];

 
 node_include("keymapper");
 $km = new KeyMapper(array(
 "editor.firstName" => "e_firstname",
 "editor.lastName" => "e_lastname",
 "creator.firstName" => "c_firstname",
 "creator.lastName" => "c_lastname",
 "channelId" => "channel_id"
 ));
 $folders = $km->remap($folders);

 $detailsComp = &$form->resolveComponent('main.details.folders');
 $detailsDS = &$detailsComp->getDatasource();
 $detailsDS->setItems($folders);

 break;
 }
}

?>