<?
GUIFactory::setMainGUI( "main" );

load_menu( 301, T_ROLE );

mysession_var_reg("ROLE_ID");

if( isset($id) ) $ROLE_ID = $id;

$ASSCORE = i18n("roles_asscore");

function saveRolePermission( &$form, $prefix, $obj_type, $contentgroup_id = NULL ) {
 global $ROLE_ID, $ROLEPERM;

 $perm = array( );
 
 $prefix .= '.c';
 $c = &$form->resolveComponent( $prefix );
 if( is_a( $c, "nodeexception" ) ) {
 echo "unable to resolve $prefix !<br/>";
 }
 foreach( $ROLEPERM[$obj_type] as $id=>$myperm ) {
 $component = &$c->getComponent( 'perm_' . $myperm['short'] );
 if( !is_a( $component, "nodeexception" ) )
 $perm[$id] = $component->isChecked() ? 1 : 0;
 }

 role_perm_saveperm( $ROLE_ID, $obj_type, $contentgroup_id, $perm );
}


function perm_haspermissions( $perm ) {
 foreach( $perm as $p ) {
 if($p) {
 return true;
 }
 }
 return false;
}




function role_perm_saveperm( $role_id, $obj_type, $contentgroup_id, $perm ) {
 global $T_CONTENTGROUP;

 $rs = perm_role_getperm( $role_id, $obj_type, $contentgroup_id );
 if( $rs['num'] > 0 ) {
 $sql = "DELETE FROM roleperm_obj WHERE roleperm_id = ".sqlf_tl_num($rs['arr'][0]['id']);
 query( $sql );
 $sql = "DELETE FROM roleperm WHERE id = ".sqlf_tl_num($rs['arr'][0]['id']);
 query( $sql );
 }

 
 if( !perm_haspermissions( $perm ) ) return;
 
 $permstr = perm2string( $perm );
 $sql = "INSERT INTO roleperm (role_id, perm) VALUES (".sqlf_tl_num($role_id).",'".sqlslashes($permstr)."')";
 $rs = query( $sql );
 $roleperm_id = $rs['iid'];
 
 $sql = "INSERT INTO roleperm_obj (roleperm_id, obj_type, obj_id) VALUES (".sqlf_tl_num($roleperm_id).", ".sqlf_tl_num($obj_type).", NULL)";
 query( $sql );
 if( $contentgroup_id ) {
 $sql = "INSERT INTO roleperm_obj (roleperm_id, obj_type, obj_id) VALUES (".sqlf_tl_num($roleperm_id).", ".sqlf_tl_num($T_CONTENTGROUP).", ".sqlf_tl_num($contentgroup_id).")";
 query( $sql );
 }

 node_include("codeparser");
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->refreshRolePerms($role_id);
}

function saveRole(&$form) {
 global $REDO, $ROLE_ID, $T_PAGE, $T_FILE, $T_FOLDER, $T_TEMPLATE;

 $nameComp = &$form->resolveComponent( 'tab.main.name' );
 $descrComp = &$form->resolveComponent( 'tab.main.description' );
 $name = $nameComp->getText();
 $description = $descrComp->getText();

 if ( ! list($name, $description) = validate_role_props($name, $description, $form) ) {
 return;
 }

 
 if( $ROLE_ID ) {
 $sql = "SELECT name_id, description_id FROM role WHERE id = ".sqlf_tl_num($ROLE_ID);
 $rs = query( $sql );
 $row = $rs['arr'][0];
 $name_id = word( $name, 6, $row['name_id'] );
 $description_id = word( $description, 6, $row['description_id'] );
 if( $name_id != $row['name_id'] || $description_id != $row['description_id'] ) {
 $sql = "UPDATE role SET name_id = '".sqlf_escaped($name_id)."', description_id = '".sqlf_escaped($description_id)."' WHERE id = ".sqlf_tl_num($ROLE_ID);
 query( $sql );
 }
 } else {
 $name_id = word( $name, 6 );
 $description_id = word( $description, 6 );
 $sql = "INSERT INTO role (name_id, description_id) values ('".sqlf_escaped($name_id)."','".sqlf_escaped($description_id)."')";

 $rs = query( $sql );
 $ROLE_ID = $rs['iid'];
 }

 
 
 saveRolePermission( $form, 'tab.pages.all', $T_PAGE );
 $sql = "SELECT id,name,code FROM contentgroup";
 $rs = query( $sql );
 foreach( $rs['arr'] as $lang ) {
 saveRolePermission( $form, 'tab.pages.lang_'.$lang['code'], $T_PAGE, $lang['id'] );
 }
 saveRolePermission( $form, 'tab.files.files', $T_FILE );
 
 

 $REDO = 551;
}

function cancelRole() {
 global $REDO;
 $REDO = 551;
}




function perm_role_getperm( $role_id, $obj_type, $contentgroup_id = NULL ) {
 global $T_CONTENTGROUP;
 $sql =
"SELECT
	roleperm.id,
	roleperm.perm
FROM roleperm
	INNER JOIN roleperm_obj AS obj_type
		ON obj_type.roleperm_id = roleperm.id
			AND obj_type.obj_id IS NULL
			AND obj_type.obj_type = ".sqlf_tl_num($obj_type)."
	LEFT JOIN roleperm_obj AS obj_lang
		ON obj_lang.roleperm_id = roleperm.id
			AND obj_lang.obj_type = ".sqlf_tl_num($T_CONTENTGROUP)."
WHERE roleperm.role_id = ".sqlf_tl_num($role_id)."
	AND obj_lang.obj_id ".($contentgroup_id ? ("= " . sqlf_tl_num($contentgroup_id)) : "IS NULL");

 $rs = query( $sql );
 return $rs;
}

function createPermissionForm(&$parent, $prefix, $type, $openDetails = true, $image = NULL, $obj_type, $contentgroup_id = NULL) {
 global $ROLE_ID, $T_CONTENTGROUP, $ROLEPERM;

 $perms = array( );
 if( $obj_type ) {
 $rs = perm_role_getperm( $ROLE_ID, $obj_type, $contentgroup_id );
 if( $rs['num'] > 0 ) {
 $permstr = $rs['arr'][0]['perm'];
 $perms = string2perm( $permstr );
 }
 }

 if( perm_haspermissions( $perms ) ) $openDetails = true;

 $list = new ListComponent();

 foreach( $ROLEPERM[$obj_type] as $id=>$perm ) {
 unset( $checkbox );
 $checkbox = new CheckboxComponent( $perm['name'], $perms[ $id ] );
 $list->setComponent( 'perm_'.$perm['short'], $checkbox );
 if( $perm['help'] ) $checkbox->setHelp( $perm['help'] );
 }

 $parent->setComponent( $prefix, $detail = new DetailComponent( $type, $type, $list ) );
 $detail->setVisible( true );
 $detail->setShowDetails( $openDetails );
 if( $image )
 $detail->setImage( $image );

}

$form = new HtmlForm3("role");
if ($form->isNew()) {
 if( $ROLE_ID ) {
 $sql = "SELECT role.id, role.name_id, role.description_id, dicname.value AS name, dicdescr.value AS description FROM role LEFT JOIN dicuser AS dicname ON dicname.output_id = role.name_id AND dicname.language_id = ".sqlf_tl_num($LANGUAGE)." LEFT JOIN dicuser AS dicdescr ON dicdescr.output_id = role.description_id AND dicdescr.language_id = ".sqlf_tl_num($LANGUAGE)." WHERE role.id = ".sqlf_tl_num($ROLE_ID);
 $rs = query( $sql );
 $row = $rs['arr'][0];
 $name = $row['name'];
 $description = $row['description'];
 }

 node_class("listcomponent");
 node_class("textcomponent");
 node_class("labelcomponent");
 node_class("radiolistcomponent");
 node_class("tabcomponent");
 node_class("detailcomponent");
 node_class( "checkboxcomponent" );
 
 $list = new ListComponent();
 
 $list->setComponent( 'name', new TextComponent( i18n('Name'), true, $name, REG_TEXT_SHORT ) );
 $list->setComponent( 'description', new TextAreaComponent( i18n('Description'),true, $description ) );


 
 $pages = new ListComponent();
 createPermissionForm( $pages, 'all', i18n( 'All Languages' ), TRUE, NULL, $T_PAGE );
 $sql = "SELECT id,name,code FROM contentgroup";
 $rs = query( $sql );
 $openDetails = $rs['num'] < 5;
 foreach( $rs['arr'] as $lang ) {
 createPermissionForm( $pages, 'lang_'.strtolower($lang['code']), $lang['name'], $openDetails, get_pageicon(0, $lang['code']), $T_PAGE, $lang['id'] );
 }

 
 $files = new ListComponent();
 createPermissionForm( $files, 'files', i18n( 'Images and Files' ), TRUE, NULL, $T_FILE );
 
 









 $tab = new TabComponent();
 $tab->setTab( 'main', i18n('General'), $list );
 $tab->setTab( 'pages', i18n('Pages'), $pages );
 $tab->setTab( 'files', i18n('Images and Files'), $files );
 
 
 
 $form->addComponent( 'tab', $tab );
 
 
 
 $form->addButton( 'save', new Button( i18n( 'Save' ) ), new SimpleFormAction( 'saveRole' ), true );
 $form->addButton( 'cancel', new Button( i18n( 'Cancel' ), false ), new SimpleFormAction( 'cancelRole' ), false );
 $form->setHeader( i18n( 'Role' ).($name ? ': '.$name : ''), $ICO_ROLE );

}

function validate_role_props($name, $description, $form) {
 node_include('validation');
 return validate_properties_htmlform3(
 array('roleName' => $name,
 'roleDescription' => $description),
 new InputValidationRequest(),
 $form,
 array('roleName' => 'tab.main.name',
 'roleDescription' => 'tab.main.description'));
}


