<?






function getFromREST($path, $params = array()) {
 if ($GLOBALS["FEATURE"]["use_php_streaming_api"]) {
 $fetcher = new FetchStream("GET");
 } else {
 $fetcher = new FetchCurl("GET");
 }

 if (!is_array($params)) {
 $params = array();
 }

 $params["sid"] = $GLOBALS["SESSION_TOKEN"];
 $url = $GLOBALS["CN_LOCAL_SERVER"] . $GLOBALS["PORTLETAPP_PREFIX_INTERNAL"] . "rest".$path."?".http_build_query($params);
 $fetcher->setURL($url);
 $json = $fetcher->doRequest();

 
 if ($fetcher->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp via {' . $url . '}');
 } else if ($fetcher->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp via {' . $url . '} returned error '.$fetcher->getReturnCode());
 }
 return json_decode($json, true);
}








function postToREST($path, $body = null, $params = array()) {
 if ($GLOBALS["FEATURE"]["use_php_streaming_api"]) {
 $fetcher = new FetchStream("POST");
 } else {
 $fetcher = new FetchCurl("POST");
 }

 if (!is_array($params)) {
 $params = array();
 }

 $params["sid"] = $GLOBALS["SESSION_TOKEN"];
 $url = $GLOBALS["CN_LOCAL_SERVER"] . $GLOBALS["PORTLETAPP_PREFIX_INTERNAL"] . "rest".$path."?".http_build_query($params);
 $fetcher->setURL($url);
 if ($body) {
 $fetcher->setPostData(json_encode($body));
 }
 $fetcher->setHeader("Content-Type", "application/json; charset=UTF-8");
 $json = $fetcher->doRequest();

 
 if ($fetcher->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp via {' . $url . '}');
 } else if ($fetcher->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp via {' . $url . '} returned error '.$fetcher->getReturnCode());
 }
 return json_decode($json, true);
}
